# This makefile has been automatically generated from the OpenSSL distribution.
# This single makefile will build the complete OpenSSL distribution and
# by default leave the 'intertesting' output files in .\out and the stuff
# that needs deleting in .\tmp.
# The file was generated by running 'make makefile.one', which
# does a 'make files', which writes all the environment variables from all
# the makefiles to the file call MINFO.  This file is used by
# util\mk1mf.pl to generate makefile.one.
# The 'makefile per directory' system suites me when developing this
# library and also so I can 'distribute' indervidual library sections.
# The one monster makefile better suits building in non-unix
# environments.

INSTALLTOP=\usr\local\ssl
OPENSSLDIR=\usr\local\ssl

# Set your compiler options
PLATFORM=VC-WIN32
CC=cl
CFLAG= /MT /Ox /O2 /Ob2 -DOPENSSL_THREADS  -DDSO_WIN32 -W3 -Gs0 -GF -Gy -nologo -DOPENSSL_SYSNAME_WIN32 -DWIN32_LEAN_AND_MEAN -DL_ENDIAN -D_CRT_SECURE_NO_DEPRECATE -DOPENSSL_BN_ASM_PART_WORDS -DOPENSSL_IA32_SSE2 -DOPENSSL_BN_ASM_MONT -DOPENSSL_BN_ASM_GF2m -DSHA1_ASM -DSHA256_ASM -DSHA512_ASM -DMD5_ASM -DRMD160_ASM -DAES_ASM -DVPAES_ASM -DWHIRLPOOL_ASM -DGHASH_ASM -DOPENSSL_NO_RC5 -DOPENSSL_NO_MDC2 -DOPENSSL_NO_CAMELLIA -DOPENSSL_NO_KRB5 -DOPENSSL_NO_JPAKE -DOPENSSL_NO_DYNAMIC_ENGINE    
APP_CFLAG= /Zi /Fd$(TMP_D)/app
LIB_CFLAG=/Zl /Zi /Fd$(TMP_D)/lib
SHLIB_CFLAG=
APP_EX_OBJ=setargv.obj
SHLIB_EX_OBJ=
# add extra libraries to this define, for solaris -lsocket -lnsl would
# be added
EX_LIBS=ws2_32.lib gdi32.lib advapi32.lib crypt32.lib user32.lib

# The OpenSSL directory
SRC_D=.

LINK=link
LFLAGS=/nologo /subsystem:console /opt:ref /debug
RSC=rc

# The output directory for everything intersting
OUT_D=out32
# The output directory for all the temporary muck
TMP_D=tmp32
# The output directory for the header files
INC_D=inc32
INCO_D=inc32\openssl

PERL=perl
CP=$(PERL) ./copy.pl
RM=del /Q
RANLIB=
MKDIR=$(PERL) ./mkdir-p.pl
MKLIB=lib /nologo
MLFLAGS=
ASM=ml /nologo /Cp /coff /c /Cx /Zi

######################################################
# You should not need to touch anything below this point
######################################################

CRYPTO=libeay32

# BIN_D  - Binary output directory
# TEST_D - Binary test file output directory
# LIB_D  - library output directory
# ENG_D  - dynamic engine output directory
# Note: if you change these point to different directories then uncomment out
# the lines around the 'NB' comment below.
# 
LIB_D=$(OUT_D)

# INCL_D - local library directory
# OBJ_D  - temp object file directory
OBJ_D=$(TMP_D)
INCL_D=$(TMP_D)

O_CRYPTO=  $(LIB_D)\$(CRYPTO).lib
SO_CRYPTO= $(CRYPTO)
L_CRYPTO=  $(LIB_D)\$(CRYPTO).lib

L_LIBS= $(L_CRYPTO) 

######################################################
# Don't touch anything below this point
######################################################

INC=-I$(INC_D) -I$(INCL_D)
APP_CFLAGS=$(INC) $(CFLAG) $(APP_CFLAG)
LIB_CFLAGS=$(INC) $(CFLAG) $(LIB_CFLAG)
SHLIB_CFLAGS=$(INC) $(CFLAG) $(LIB_CFLAG) $(SHLIB_CFLAG)
LIBS_DEP=$(O_CRYPTO)

#############################################
HEADER=$(INCL_D)\Version.h $(INCL_D)\e_os.h \
	$(INCL_D)\cryptlib.h $(INCL_D)\buildinf.h $(INCL_D)\md32_common.h \
	$(INCL_D)\o_time.h $(INCL_D)\o_str.h $(INCL_D)\o_dir.h \
	$(INCL_D)\md4_locl.h $(INCL_D)\md5_locl.h $(INCL_D)\sha_locl.h \
	$(INCL_D)\rmd_locl.h $(INCL_D)\rmdconst.h $(INCL_D)\des_locl.h \
	$(INCL_D)\rpc_des.h $(INCL_D)\spr.h $(INCL_D)\des_ver.h \
	$(INCL_D)\rc2_locl.h $(INCL_D)\rc4_locl.h $(INCL_D)\idea_lcl.h \
	$(INCL_D)\bf_pi.h $(INCL_D)\bf_locl.h $(INCL_D)\cast_s.h \
	$(INCL_D)\cast_lcl.h $(INCL_D)\aes_locl.h \
	$(INCL_D)\modes_lcl.h $(INCL_D)\bn_lcl.h \
	$(INCL_D)\bn_prime.h $(INCL_D)\dsa_locl.h $(INCL_D)\ec_lcl.h \
	$(INCL_D)\ech_locl.h $(INCL_D)\ecs_locl.h $(INCL_D)\bio_lcl.h \
	$(INCL_D)\obj_dat.h $(INCL_D)\obj_xref.h $(INCL_D)\evp_locl.h \
	$(INCL_D)\asn1_locl.h $(INCL_D)\pcy_int.h \
	$(INCL_D)\conf_def.h $(INCL_D)\ui_locl.h $(INCL_D)\wp_locl.h

EXHEADER=$(INCO_D)\e_os2.h \
	$(INCO_D)\crypto.h $(INCO_D)\opensslv.h $(INCO_D)\opensslconf.h \
	$(INCO_D)\ebcdic.h $(INCO_D)\symhacks.h $(INCO_D)\ossl_typ.h \
	$(INCO_D)\md4.h $(INCO_D)\md5.h $(INCO_D)\sha.h \
	$(INCO_D)\md2.h $(INCO_D)\hmac.h $(INCO_D)\cmac.h \
	$(INCO_D)\ripemd.h $(INCO_D)\des.h $(INCO_D)\des_old.h \
	$(INCO_D)\rc2.h $(INCO_D)\rc4.h $(INCO_D)\idea.h \
	$(INCO_D)\blowfish.h $(INCO_D)\cast.h $(INCO_D)\aes.h \
	$(INCO_D)\modes.h \
	$(INCO_D)\bn.h $(INCO_D)\rsa.h $(INCO_D)\dsa.h \
	$(INCO_D)\dso.h $(INCO_D)\dh.h $(INCO_D)\ec.h \
	$(INCO_D)\ecdh.h $(INCO_D)\ecdsa.h $(INCO_D)\buffer.h \
	$(INCO_D)\bio.h $(INCO_D)\stack.h $(INCO_D)\safestack.h \
	$(INCO_D)\lhash.h $(INCO_D)\rand.h $(INCO_D)\err.h \
	$(INCO_D)\objects.h $(INCO_D)\obj_mac.h $(INCO_D)\evp.h \
	$(INCO_D)\asn1.h $(INCO_D)\asn1_mac.h $(INCO_D)\asn1t.h \
	$(INCO_D)\pem.h $(INCO_D)\pem2.h $(INCO_D)\x509.h \
	$(INCO_D)\x509_vfy.h $(INCO_D)\x509v3.h \
	$(INCO_D)\conf.h $(INCO_D)\conf_api.h $(INCO_D)\txt_db.h \
	$(INCO_D)\pkcs7.h $(INCO_D)\pkcs12.h $(INCO_D)\comp.h \
	$(INCO_D)\engine.h $(INCO_D)\ocsp.h $(INCO_D)\ui.h \
	$(INCO_D)\ui_compat.h $(INCO_D)\krb5_asn.h $(INCO_D)\pqueue.h \
	$(INCO_D)\whrlpool.h $(INCO_D)\ts.h $(INCO_D)\srp.h

CRYPTOOBJ=$(OBJ_D)\cryptlib.obj \
	$(OBJ_D)\mem.obj $(OBJ_D)\mem_dbg.obj $(OBJ_D)\cversion.obj \
	$(OBJ_D)\ex_data.obj $(OBJ_D)\cpt_err.obj $(OBJ_D)\ebcdic.obj \
	$(OBJ_D)\uid.obj $(OBJ_D)\o_time.obj $(OBJ_D)\o_str.obj \
	$(OBJ_D)\o_dir.obj $(OBJ_D)\o_fips.obj $(OBJ_D)\o_init.obj \
	$(OBJ_D)\x86cpuid.obj $(OBJ_D)\md4_dgst.obj \
	$(OBJ_D)\md4_one.obj $(OBJ_D)\md5_dgst.obj $(OBJ_D)\md5_one.obj \
	$(OBJ_D)\md5-586.obj $(OBJ_D)\sha_dgst.obj $(OBJ_D)\sha1dgst.obj \
	$(OBJ_D)\sha_one.obj $(OBJ_D)\sha1_one.obj $(OBJ_D)\sha256.obj \
	$(OBJ_D)\sha512.obj $(OBJ_D)\sha1-586.obj $(OBJ_D)\sha256-586.obj \
	$(OBJ_D)\sha512-586.obj $(OBJ_D)\md2_dgst.obj $(OBJ_D)\md2_one.obj \
	$(OBJ_D)\hmac.obj $(OBJ_D)\hm_ameth.obj $(OBJ_D)\hm_pmeth.obj \
	$(OBJ_D)\cmac.obj $(OBJ_D)\cm_ameth.obj $(OBJ_D)\cm_pmeth.obj \
	$(OBJ_D)\rmd_dgst.obj $(OBJ_D)\rmd_one.obj $(OBJ_D)\rmd-586.obj \
	$(OBJ_D)\set_key.obj $(OBJ_D)\ecb_enc.obj $(OBJ_D)\cbc_enc.obj \
	$(OBJ_D)\ecb3_enc.obj $(OBJ_D)\cfb64enc.obj $(OBJ_D)\cfb64ede.obj \
	$(OBJ_D)\cfb_enc.obj $(OBJ_D)\ofb64ede.obj $(OBJ_D)\enc_read.obj \
	$(OBJ_D)\enc_writ.obj $(OBJ_D)\ofb64enc.obj $(OBJ_D)\ofb_enc.obj \
	$(OBJ_D)\str2key.obj $(OBJ_D)\pcbc_enc.obj $(OBJ_D)\qud_cksm.obj \
	$(OBJ_D)\rand_key.obj $(OBJ_D)\des-586.obj $(OBJ_D)\crypt586.obj \
	$(OBJ_D)\fcrypt.obj $(OBJ_D)\xcbc_enc.obj $(OBJ_D)\rpc_enc.obj \
	$(OBJ_D)\cbc_cksm.obj $(OBJ_D)\ede_cbcm_enc.obj $(OBJ_D)\des_old.obj \
	$(OBJ_D)\des_old2.obj $(OBJ_D)\read2pwd.obj $(OBJ_D)\rc2_ecb.obj \
	$(OBJ_D)\rc2_skey.obj $(OBJ_D)\rc2_cbc.obj $(OBJ_D)\rc2cfb64.obj \
	$(OBJ_D)\rc2ofb64.obj $(OBJ_D)\rc4-586.obj $(OBJ_D)\rc4_utl.obj \
	$(OBJ_D)\i_cbc.obj $(OBJ_D)\i_cfb64.obj $(OBJ_D)\i_ofb64.obj \
	$(OBJ_D)\i_ecb.obj $(OBJ_D)\i_skey.obj $(OBJ_D)\bf_skey.obj \
	$(OBJ_D)\bf_ecb.obj $(OBJ_D)\bf-586.obj $(OBJ_D)\bf_cfb64.obj \
	$(OBJ_D)\bf_ofb64.obj $(OBJ_D)\c_skey.obj $(OBJ_D)\c_ecb.obj \
	$(OBJ_D)\cast-586.obj $(OBJ_D)\c_cfb64.obj $(OBJ_D)\c_ofb64.obj \
	$(OBJ_D)\aes_misc.obj $(OBJ_D)\aes_ecb.obj $(OBJ_D)\aes_cfb.obj \
	$(OBJ_D)\aes_ofb.obj $(OBJ_D)\aes_ctr.obj $(OBJ_D)\aes_ige.obj \
	$(OBJ_D)\aes_wrap.obj $(OBJ_D)\aes-586.obj $(OBJ_D)\vpaes-x86.obj \
	$(OBJ_D)\aesni-x86.obj \
	$(OBJ_D)\cbc128.obj $(OBJ_D)\ctr128.obj $(OBJ_D)\cts128.obj \
	$(OBJ_D)\cfb128.obj $(OBJ_D)\ofb128.obj $(OBJ_D)\gcm128.obj \
	$(OBJ_D)\ccm128.obj $(OBJ_D)\xts128.obj $(OBJ_D)\ghash-x86.obj \
	$(OBJ_D)\bn_add.obj $(OBJ_D)\bn_div.obj $(OBJ_D)\bn_exp.obj \
	$(OBJ_D)\bn_lib.obj $(OBJ_D)\bn_ctx.obj $(OBJ_D)\bn_mul.obj \
	$(OBJ_D)\bn_mod.obj $(OBJ_D)\bn_print.obj $(OBJ_D)\bn_rand.obj \
	$(OBJ_D)\bn_shift.obj $(OBJ_D)\bn_word.obj $(OBJ_D)\bn_blind.obj \
	$(OBJ_D)\bn_kron.obj $(OBJ_D)\bn_sqrt.obj $(OBJ_D)\bn_gcd.obj \
	$(OBJ_D)\bn_prime.obj $(OBJ_D)\bn_err.obj $(OBJ_D)\bn_sqr.obj \
	$(OBJ_D)\bn-586.obj $(OBJ_D)\co-586.obj $(OBJ_D)\x86-mont.obj \
	$(OBJ_D)\x86-gf2m.obj $(OBJ_D)\bn_recp.obj $(OBJ_D)\bn_mont.obj \
	$(OBJ_D)\bn_mpi.obj $(OBJ_D)\bn_exp2.obj $(OBJ_D)\bn_gf2m.obj \
	$(OBJ_D)\bn_nist.obj $(OBJ_D)\bn_depr.obj $(OBJ_D)\bn_const.obj \
	$(OBJ_D)\bn_x931p.obj $(OBJ_D)\rsa_eay.obj $(OBJ_D)\rsa_gen.obj \
	$(OBJ_D)\rsa_lib.obj $(OBJ_D)\rsa_sign.obj $(OBJ_D)\rsa_saos.obj \
	$(OBJ_D)\rsa_err.obj $(OBJ_D)\rsa_pk1.obj $(OBJ_D)\rsa_ssl.obj \
	$(OBJ_D)\rsa_none.obj $(OBJ_D)\rsa_oaep.obj $(OBJ_D)\rsa_chk.obj \
	$(OBJ_D)\rsa_null.obj $(OBJ_D)\rsa_pss.obj $(OBJ_D)\rsa_x931.obj \
	$(OBJ_D)\rsa_asn1.obj $(OBJ_D)\rsa_depr.obj $(OBJ_D)\rsa_ameth.obj \
	$(OBJ_D)\rsa_prn.obj $(OBJ_D)\rsa_pmeth.obj $(OBJ_D)\rsa_crpt.obj \
	$(OBJ_D)\dsa_gen.obj $(OBJ_D)\dsa_key.obj $(OBJ_D)\dsa_lib.obj \
	$(OBJ_D)\dsa_asn1.obj $(OBJ_D)\dsa_vrf.obj $(OBJ_D)\dsa_sign.obj \
	$(OBJ_D)\dsa_err.obj $(OBJ_D)\dsa_ossl.obj $(OBJ_D)\dsa_depr.obj \
	$(OBJ_D)\dsa_ameth.obj $(OBJ_D)\dsa_pmeth.obj $(OBJ_D)\dsa_prn.obj \
	$(OBJ_D)\dso_dl.obj $(OBJ_D)\dso_dlfcn.obj $(OBJ_D)\dso_err.obj \
	$(OBJ_D)\dso_lib.obj $(OBJ_D)\dso_null.obj $(OBJ_D)\dso_openssl.obj \
	$(OBJ_D)\dso_win32.obj $(OBJ_D)\dso_vms.obj $(OBJ_D)\dso_beos.obj \
	$(OBJ_D)\dh_asn1.obj $(OBJ_D)\dh_gen.obj $(OBJ_D)\dh_key.obj \
	$(OBJ_D)\dh_lib.obj $(OBJ_D)\dh_check.obj $(OBJ_D)\dh_err.obj \
	$(OBJ_D)\dh_depr.obj $(OBJ_D)\dh_ameth.obj $(OBJ_D)\dh_pmeth.obj \
	$(OBJ_D)\dh_prn.obj $(OBJ_D)\ec_lib.obj $(OBJ_D)\ecp_smpl.obj \
	$(OBJ_D)\ecp_mont.obj $(OBJ_D)\ecp_nist.obj $(OBJ_D)\ec_cvt.obj \
	$(OBJ_D)\ec_mult.obj $(OBJ_D)\ec_err.obj $(OBJ_D)\ec_curve.obj \
	$(OBJ_D)\ec_check.obj $(OBJ_D)\ec_print.obj $(OBJ_D)\ec_asn1.obj \
	$(OBJ_D)\ec_key.obj $(OBJ_D)\ec2_smpl.obj $(OBJ_D)\ec2_mult.obj \
	$(OBJ_D)\ec_ameth.obj $(OBJ_D)\ec_pmeth.obj $(OBJ_D)\eck_prn.obj \
	$(OBJ_D)\ecp_oct.obj $(OBJ_D)\ec2_oct.obj \
	$(OBJ_D)\ec_oct.obj $(OBJ_D)\ech_lib.obj $(OBJ_D)\ech_ossl.obj \
	$(OBJ_D)\ech_key.obj $(OBJ_D)\ech_err.obj $(OBJ_D)\ecs_lib.obj \
	$(OBJ_D)\ecs_asn1.obj $(OBJ_D)\ecs_ossl.obj $(OBJ_D)\ecs_sign.obj \
	$(OBJ_D)\ecs_vrf.obj $(OBJ_D)\ecs_err.obj $(OBJ_D)\buffer.obj \
	$(OBJ_D)\buf_str.obj $(OBJ_D)\buf_err.obj $(OBJ_D)\bio_lib.obj \
	$(OBJ_D)\bio_cb.obj $(OBJ_D)\bio_err.obj $(OBJ_D)\bss_mem.obj \
	$(OBJ_D)\bss_null.obj $(OBJ_D)\bss_fd.obj $(OBJ_D)\bss_file.obj \
	$(OBJ_D)\bss_sock.obj $(OBJ_D)\bss_conn.obj $(OBJ_D)\bf_null.obj \
	$(OBJ_D)\bf_buff.obj $(OBJ_D)\b_print.obj $(OBJ_D)\b_dump.obj \
	$(OBJ_D)\b_sock.obj $(OBJ_D)\bss_acpt.obj $(OBJ_D)\bf_nbio.obj \
	$(OBJ_D)\bss_log.obj $(OBJ_D)\bss_bio.obj $(OBJ_D)\bss_dgram.obj \
	$(OBJ_D)\stack.obj $(OBJ_D)\lhash.obj $(OBJ_D)\lh_stats.obj \
	$(OBJ_D)\md_rand.obj $(OBJ_D)\randfile.obj $(OBJ_D)\rand_lib.obj \
	$(OBJ_D)\rand_err.obj $(OBJ_D)\rand_egd.obj $(OBJ_D)\rand_win.obj \
	$(OBJ_D)\rand_unix.obj $(OBJ_D)\rand_os2.obj $(OBJ_D)\rand_nw.obj \
	$(OBJ_D)\err.obj $(OBJ_D)\err_all.obj $(OBJ_D)\err_prn.obj \
	$(OBJ_D)\o_names.obj $(OBJ_D)\obj_dat.obj $(OBJ_D)\obj_lib.obj \
	$(OBJ_D)\obj_err.obj $(OBJ_D)\obj_xref.obj $(OBJ_D)\encode.obj \
	$(OBJ_D)\digest.obj $(OBJ_D)\evp_enc.obj $(OBJ_D)\evp_key.obj \
	$(OBJ_D)\evp_acnf.obj $(OBJ_D)\evp_cnf.obj $(OBJ_D)\e_des.obj \
	$(OBJ_D)\e_bf.obj $(OBJ_D)\e_idea.obj $(OBJ_D)\e_des3.obj \
	$(OBJ_D)\e_rc4.obj $(OBJ_D)\e_aes.obj \
	$(OBJ_D)\names.obj $(OBJ_D)\e_xcbc_d.obj \
	$(OBJ_D)\e_rc2.obj $(OBJ_D)\e_cast.obj $(OBJ_D)\e_rc5.obj \
	$(OBJ_D)\m_null.obj $(OBJ_D)\m_md4.obj $(OBJ_D)\m_md5.obj \
	$(OBJ_D)\m_sha.obj $(OBJ_D)\m_sha1.obj $(OBJ_D)\m_wp.obj \
	$(OBJ_D)\m_dss.obj $(OBJ_D)\m_dss1.obj $(OBJ_D)\m_md2.obj \
	$(OBJ_D)\m_ripemd.obj $(OBJ_D)\m_ecdsa.obj $(OBJ_D)\p_open.obj \
	$(OBJ_D)\p_seal.obj $(OBJ_D)\p_sign.obj $(OBJ_D)\p_verify.obj \
	$(OBJ_D)\p_lib.obj $(OBJ_D)\p_enc.obj $(OBJ_D)\p_dec.obj \
	$(OBJ_D)\bio_md.obj $(OBJ_D)\bio_b64.obj $(OBJ_D)\bio_enc.obj \
	$(OBJ_D)\evp_err.obj $(OBJ_D)\e_null.obj $(OBJ_D)\c_all.obj \
	$(OBJ_D)\c_allc.obj $(OBJ_D)\c_alld.obj $(OBJ_D)\evp_lib.obj \
	$(OBJ_D)\bio_ok.obj $(OBJ_D)\evp_pkey.obj $(OBJ_D)\evp_pbe.obj \
	$(OBJ_D)\p5_crpt.obj $(OBJ_D)\p5_crpt2.obj $(OBJ_D)\e_old.obj \
	$(OBJ_D)\pmeth_lib.obj $(OBJ_D)\pmeth_fn.obj $(OBJ_D)\pmeth_gn.obj \
	$(OBJ_D)\m_sigver.obj $(OBJ_D)\evp_fips.obj $(OBJ_D)\e_aes_cbc_hmac_sha1.obj \
	$(OBJ_D)\e_rc4_hmac_md5.obj $(OBJ_D)\a_object.obj $(OBJ_D)\a_bitstr.obj \
	$(OBJ_D)\a_utctm.obj $(OBJ_D)\a_gentm.obj $(OBJ_D)\a_time.obj \
	$(OBJ_D)\a_int.obj $(OBJ_D)\a_octet.obj $(OBJ_D)\a_print.obj \
	$(OBJ_D)\a_type.obj $(OBJ_D)\a_set.obj $(OBJ_D)\a_dup.obj \
	$(OBJ_D)\a_d2i_fp.obj $(OBJ_D)\a_i2d_fp.obj $(OBJ_D)\a_enum.obj \
	$(OBJ_D)\a_utf8.obj $(OBJ_D)\a_sign.obj $(OBJ_D)\a_digest.obj \
	$(OBJ_D)\a_verify.obj $(OBJ_D)\a_mbstr.obj $(OBJ_D)\a_strex.obj \
	$(OBJ_D)\x_algor.obj $(OBJ_D)\x_val.obj $(OBJ_D)\x_pubkey.obj \
	$(OBJ_D)\x_sig.obj $(OBJ_D)\x_req.obj $(OBJ_D)\x_attrib.obj \
	$(OBJ_D)\x_bignum.obj $(OBJ_D)\x_long.obj $(OBJ_D)\x_name.obj \
	$(OBJ_D)\x_x509.obj $(OBJ_D)\x_x509a.obj $(OBJ_D)\x_crl.obj \
	$(OBJ_D)\x_info.obj $(OBJ_D)\x_spki.obj $(OBJ_D)\nsseq.obj \
	$(OBJ_D)\x_nx509.obj $(OBJ_D)\d2i_pu.obj $(OBJ_D)\d2i_pr.obj \
	$(OBJ_D)\i2d_pu.obj $(OBJ_D)\i2d_pr.obj $(OBJ_D)\t_req.obj \
	$(OBJ_D)\t_x509.obj $(OBJ_D)\t_x509a.obj $(OBJ_D)\t_crl.obj \
	$(OBJ_D)\t_pkey.obj $(OBJ_D)\t_spki.obj $(OBJ_D)\t_bitst.obj \
	$(OBJ_D)\tasn_new.obj $(OBJ_D)\tasn_fre.obj $(OBJ_D)\tasn_enc.obj \
	$(OBJ_D)\tasn_dec.obj $(OBJ_D)\tasn_utl.obj $(OBJ_D)\tasn_typ.obj \
	$(OBJ_D)\tasn_prn.obj $(OBJ_D)\ameth_lib.obj $(OBJ_D)\f_int.obj \
	$(OBJ_D)\f_string.obj $(OBJ_D)\n_pkey.obj $(OBJ_D)\f_enum.obj \
	$(OBJ_D)\x_pkey.obj $(OBJ_D)\a_bool.obj $(OBJ_D)\x_exten.obj \
	$(OBJ_D)\bio_asn1.obj $(OBJ_D)\bio_ndef.obj $(OBJ_D)\asn_mime.obj \
	$(OBJ_D)\asn1_gen.obj $(OBJ_D)\asn1_par.obj $(OBJ_D)\asn1_lib.obj \
	$(OBJ_D)\asn1_err.obj $(OBJ_D)\a_bytes.obj $(OBJ_D)\a_strnid.obj \
	$(OBJ_D)\evp_asn1.obj $(OBJ_D)\asn_pack.obj $(OBJ_D)\p5_pbe.obj \
	$(OBJ_D)\p5_pbev2.obj $(OBJ_D)\p8_pkey.obj $(OBJ_D)\asn_moid.obj \
	$(OBJ_D)\pem_sign.obj $(OBJ_D)\pem_seal.obj $(OBJ_D)\pem_info.obj \
	$(OBJ_D)\pem_lib.obj $(OBJ_D)\pem_all.obj $(OBJ_D)\pem_err.obj \
	$(OBJ_D)\pem_x509.obj $(OBJ_D)\pem_xaux.obj $(OBJ_D)\pem_oth.obj \
	$(OBJ_D)\pem_pk8.obj $(OBJ_D)\pem_pkey.obj $(OBJ_D)\pvkfmt.obj \
	$(OBJ_D)\x509_def.obj $(OBJ_D)\x509_d2.obj $(OBJ_D)\x509_r2x.obj \
	$(OBJ_D)\x509_cmp.obj $(OBJ_D)\x509_obj.obj $(OBJ_D)\x509_req.obj \
	$(OBJ_D)\x509spki.obj $(OBJ_D)\x509_vfy.obj $(OBJ_D)\x509_set.obj \
	$(OBJ_D)\x509cset.obj $(OBJ_D)\x509rset.obj $(OBJ_D)\x509_err.obj \
	$(OBJ_D)\x509name.obj $(OBJ_D)\x509_v3.obj $(OBJ_D)\x509_ext.obj \
	$(OBJ_D)\x509_att.obj $(OBJ_D)\x509type.obj $(OBJ_D)\x509_lu.obj \
	$(OBJ_D)\x_all.obj $(OBJ_D)\x509_txt.obj $(OBJ_D)\x509_trs.obj \
	$(OBJ_D)\by_file.obj $(OBJ_D)\by_dir.obj $(OBJ_D)\x509_vpm.obj \
	$(OBJ_D)\v3_bcons.obj $(OBJ_D)\v3_bitst.obj $(OBJ_D)\v3_conf.obj \
	$(OBJ_D)\v3_extku.obj $(OBJ_D)\v3_ia5.obj $(OBJ_D)\v3_lib.obj \
	$(OBJ_D)\v3_prn.obj $(OBJ_D)\v3_utl.obj $(OBJ_D)\v3err.obj \
	$(OBJ_D)\v3_genn.obj $(OBJ_D)\v3_alt.obj $(OBJ_D)\v3_skey.obj \
	$(OBJ_D)\v3_akey.obj $(OBJ_D)\v3_pku.obj $(OBJ_D)\v3_int.obj \
	$(OBJ_D)\v3_enum.obj $(OBJ_D)\v3_sxnet.obj $(OBJ_D)\v3_cpols.obj \
	$(OBJ_D)\v3_crld.obj $(OBJ_D)\v3_purp.obj $(OBJ_D)\v3_info.obj \
	$(OBJ_D)\v3_ocsp.obj $(OBJ_D)\v3_akeya.obj $(OBJ_D)\v3_pmaps.obj \
	$(OBJ_D)\v3_pcons.obj $(OBJ_D)\v3_ncons.obj $(OBJ_D)\v3_pcia.obj \
	$(OBJ_D)\v3_pci.obj $(OBJ_D)\pcy_cache.obj $(OBJ_D)\pcy_node.obj \
	$(OBJ_D)\pcy_data.obj $(OBJ_D)\pcy_map.obj $(OBJ_D)\pcy_tree.obj \
	$(OBJ_D)\pcy_lib.obj $(OBJ_D)\v3_asid.obj $(OBJ_D)\v3_addr.obj \
	$(OBJ_D)\conf_err.obj $(OBJ_D)\conf_lib.obj \
	$(OBJ_D)\conf_api.obj $(OBJ_D)\conf_def.obj $(OBJ_D)\conf_mod.obj \
	$(OBJ_D)\conf_mall.obj $(OBJ_D)\conf_sap.obj $(OBJ_D)\txt_db.obj \
	$(OBJ_D)\pk7_asn1.obj $(OBJ_D)\pk7_lib.obj $(OBJ_D)\pkcs7err.obj \
	$(OBJ_D)\pk7_doit.obj $(OBJ_D)\pk7_smime.obj $(OBJ_D)\pk7_attr.obj \
	$(OBJ_D)\pk7_mime.obj $(OBJ_D)\bio_pk7.obj $(OBJ_D)\p12_add.obj \
	$(OBJ_D)\p12_asn.obj $(OBJ_D)\p12_attr.obj $(OBJ_D)\p12_crpt.obj \
	$(OBJ_D)\p12_crt.obj $(OBJ_D)\p12_decr.obj $(OBJ_D)\p12_init.obj \
	$(OBJ_D)\p12_key.obj $(OBJ_D)\p12_kiss.obj $(OBJ_D)\p12_mutl.obj \
	$(OBJ_D)\p12_utl.obj $(OBJ_D)\p12_npas.obj $(OBJ_D)\pk12err.obj \
	$(OBJ_D)\p12_p8d.obj $(OBJ_D)\p12_p8e.obj $(OBJ_D)\comp_lib.obj \
	$(OBJ_D)\comp_err.obj $(OBJ_D)\c_rle.obj $(OBJ_D)\c_zlib.obj \
	$(OBJ_D)\eng_err.obj $(OBJ_D)\eng_lib.obj $(OBJ_D)\eng_list.obj \
	$(OBJ_D)\eng_init.obj $(OBJ_D)\eng_ctrl.obj $(OBJ_D)\eng_table.obj \
	$(OBJ_D)\eng_pkey.obj $(OBJ_D)\eng_fat.obj $(OBJ_D)\eng_all.obj \
	$(OBJ_D)\tb_rsa.obj $(OBJ_D)\tb_dsa.obj $(OBJ_D)\tb_ecdsa.obj \
	$(OBJ_D)\tb_dh.obj $(OBJ_D)\tb_ecdh.obj $(OBJ_D)\tb_rand.obj \
	$(OBJ_D)\tb_store.obj $(OBJ_D)\tb_cipher.obj $(OBJ_D)\tb_digest.obj \
	$(OBJ_D)\tb_pkmeth.obj $(OBJ_D)\tb_asnmth.obj $(OBJ_D)\eng_openssl.obj \
	$(OBJ_D)\eng_cnf.obj $(OBJ_D)\eng_dyn.obj $(OBJ_D)\eng_cryptodev.obj \
	$(OBJ_D)\eng_rsax.obj $(OBJ_D)\eng_rdrand.obj $(OBJ_D)\ocsp_asn.obj \
	$(OBJ_D)\ocsp_ext.obj $(OBJ_D)\ocsp_ht.obj $(OBJ_D)\ocsp_lib.obj \
	$(OBJ_D)\ocsp_cl.obj $(OBJ_D)\ocsp_srv.obj $(OBJ_D)\ocsp_prn.obj \
	$(OBJ_D)\ocsp_vfy.obj $(OBJ_D)\ocsp_err.obj $(OBJ_D)\ui_err.obj \
	$(OBJ_D)\ui_lib.obj $(OBJ_D)\ui_openssl.obj $(OBJ_D)\ui_util.obj \
	$(OBJ_D)\ui_compat.obj $(OBJ_D)\krb5_asn.obj $(OBJ_D)\pqueue.obj \
	$(OBJ_D)\wp_dgst.obj $(OBJ_D)\wp_block.obj $(OBJ_D)\wp-mmx.obj \
	$(OBJ_D)\ts_err.obj $(OBJ_D)\ts_req_utils.obj $(OBJ_D)\ts_req_print.obj \
	$(OBJ_D)\ts_rsp_utils.obj $(OBJ_D)\ts_rsp_print.obj $(OBJ_D)\ts_rsp_sign.obj \
	$(OBJ_D)\ts_rsp_verify.obj $(OBJ_D)\ts_verify_ctx.obj $(OBJ_D)\ts_lib.obj \
	$(OBJ_D)\ts_conf.obj $(OBJ_D)\ts_asn1.obj $(OBJ_D)\srp_lib.obj \
	$(OBJ_D)\srp_vfy.obj

E_SHLIB=

###################################################################
all: banner $(TMP_D) $(BIN_D) $(TEST_D) $(LIB_D) $(INCO_D) headers lib

banner:
	@echo Building OpenSSL

$(TMP_D):
	$(MKDIR) "$(TMP_D)"
# NB: uncomment out these lines if BIN_D, TEST_D and LIB_D are different
#$(BIN_D):
#	$(MKDIR) $(BIN_D)
#
#$(TEST_D):
#	$(MKDIR) $(TEST_D)

$(LIB_D):
	$(MKDIR) "$(LIB_D)"

$(INCO_D): $(INC_D)
	$(MKDIR) "$(INCO_D)"

$(INC_D):
	$(MKDIR) "$(INC_D)"

headers: $(HEADER) $(EXHEADER)
	@

lib: $(LIBS_DEP) $(E_SHLIB)

clean:
	$(RM) $(TMP_D)\*.*

vclean:
	$(RM) $(TMP_D)\*.*
	$(RM) $(OUT_D)\*.*

$(INCL_D)\Version.h: $(SRC_D)\..\..\..\Version.h
	$(CP) "$(SRC_D)\..\..\..\Version.h" "$(INCL_D)\Version.h"

$(INCL_D)\e_os.h: $(SRC_D)\.\e_os.h
	$(CP) "$(SRC_D)\.\e_os.h" "$(INCL_D)\e_os.h"

$(INCL_D)\cryptlib.h: $(SRC_D)\crypto\cryptlib.h
	$(CP) "$(SRC_D)\crypto\cryptlib.h" "$(INCL_D)\cryptlib.h"

$(INCL_D)\buildinf.h: $(SRC_D)\..\Include\buildinf.h
	$(CP) "$(SRC_D)\..\Include\buildinf.h" "$(INCL_D)\buildinf.h"

$(INCL_D)\md32_common.h: $(SRC_D)\crypto\md32_common.h
	$(CP) "$(SRC_D)\crypto\md32_common.h" "$(INCL_D)\md32_common.h"

$(INCL_D)\o_time.h: $(SRC_D)\crypto\o_time.h
	$(CP) "$(SRC_D)\crypto\o_time.h" "$(INCL_D)\o_time.h"

$(INCL_D)\o_str.h: $(SRC_D)\crypto\o_str.h
	$(CP) "$(SRC_D)\crypto\o_str.h" "$(INCL_D)\o_str.h"

$(INCL_D)\o_dir.h: $(SRC_D)\crypto\o_dir.h
	$(CP) "$(SRC_D)\crypto\o_dir.h" "$(INCL_D)\o_dir.h"

$(INCL_D)\md4_locl.h: $(SRC_D)\crypto\md4\md4_locl.h
	$(CP) "$(SRC_D)\crypto\md4\md4_locl.h" "$(INCL_D)\md4_locl.h"

$(INCL_D)\md5_locl.h: $(SRC_D)\crypto\md5\md5_locl.h
	$(CP) "$(SRC_D)\crypto\md5\md5_locl.h" "$(INCL_D)\md5_locl.h"

$(INCL_D)\sha_locl.h: $(SRC_D)\crypto\sha\sha_locl.h
	$(CP) "$(SRC_D)\crypto\sha\sha_locl.h" "$(INCL_D)\sha_locl.h"

$(INCL_D)\rmd_locl.h: $(SRC_D)\crypto\ripemd\rmd_locl.h
	$(CP) "$(SRC_D)\crypto\ripemd\rmd_locl.h" "$(INCL_D)\rmd_locl.h"

$(INCL_D)\rmdconst.h: $(SRC_D)\crypto\ripemd\rmdconst.h
	$(CP) "$(SRC_D)\crypto\ripemd\rmdconst.h" "$(INCL_D)\rmdconst.h"

$(INCL_D)\des_locl.h: $(SRC_D)\crypto\des\des_locl.h
	$(CP) "$(SRC_D)\crypto\des\des_locl.h" "$(INCL_D)\des_locl.h"

$(INCL_D)\rpc_des.h: $(SRC_D)\crypto\des\rpc_des.h
	$(CP) "$(SRC_D)\crypto\des\rpc_des.h" "$(INCL_D)\rpc_des.h"

$(INCL_D)\spr.h: $(SRC_D)\crypto\des\spr.h
	$(CP) "$(SRC_D)\crypto\des\spr.h" "$(INCL_D)\spr.h"

$(INCL_D)\des_ver.h: $(SRC_D)\crypto\des\des_ver.h
	$(CP) "$(SRC_D)\crypto\des\des_ver.h" "$(INCL_D)\des_ver.h"

$(INCL_D)\rc2_locl.h: $(SRC_D)\crypto\rc2\rc2_locl.h
	$(CP) "$(SRC_D)\crypto\rc2\rc2_locl.h" "$(INCL_D)\rc2_locl.h"

$(INCL_D)\rc4_locl.h: $(SRC_D)\crypto\rc4\rc4_locl.h
	$(CP) "$(SRC_D)\crypto\rc4\rc4_locl.h" "$(INCL_D)\rc4_locl.h"

$(INCL_D)\idea_lcl.h: $(SRC_D)\crypto\idea\idea_lcl.h
	$(CP) "$(SRC_D)\crypto\idea\idea_lcl.h" "$(INCL_D)\idea_lcl.h"

$(INCL_D)\bf_pi.h: $(SRC_D)\crypto\bf\bf_pi.h
	$(CP) "$(SRC_D)\crypto\bf\bf_pi.h" "$(INCL_D)\bf_pi.h"

$(INCL_D)\bf_locl.h: $(SRC_D)\crypto\bf\bf_locl.h
	$(CP) "$(SRC_D)\crypto\bf\bf_locl.h" "$(INCL_D)\bf_locl.h"

$(INCL_D)\cast_s.h: $(SRC_D)\crypto\cast\cast_s.h
	$(CP) "$(SRC_D)\crypto\cast\cast_s.h" "$(INCL_D)\cast_s.h"

$(INCL_D)\cast_lcl.h: $(SRC_D)\crypto\cast\cast_lcl.h
	$(CP) "$(SRC_D)\crypto\cast\cast_lcl.h" "$(INCL_D)\cast_lcl.h"

$(INCL_D)\aes_locl.h: $(SRC_D)\crypto\aes\aes_locl.h
	$(CP) "$(SRC_D)\crypto\aes\aes_locl.h" "$(INCL_D)\aes_locl.h"

$(INCL_D)\modes_lcl.h: $(SRC_D)\crypto\modes\modes_lcl.h
	$(CP) "$(SRC_D)\crypto\modes\modes_lcl.h" "$(INCL_D)\modes_lcl.h"

$(INCL_D)\bn_lcl.h: $(SRC_D)\crypto\bn\bn_lcl.h
	$(CP) "$(SRC_D)\crypto\bn\bn_lcl.h" "$(INCL_D)\bn_lcl.h"

$(INCL_D)\bn_prime.h: $(SRC_D)\crypto\bn\bn_prime.h
	$(CP) "$(SRC_D)\crypto\bn\bn_prime.h" "$(INCL_D)\bn_prime.h"

$(INCL_D)\dsa_locl.h: $(SRC_D)\crypto\dsa\dsa_locl.h
	$(CP) "$(SRC_D)\crypto\dsa\dsa_locl.h" "$(INCL_D)\dsa_locl.h"

$(INCL_D)\ec_lcl.h: $(SRC_D)\crypto\ec\ec_lcl.h
	$(CP) "$(SRC_D)\crypto\ec\ec_lcl.h" "$(INCL_D)\ec_lcl.h"

$(INCL_D)\ech_locl.h: $(SRC_D)\crypto\ecdh\ech_locl.h
	$(CP) "$(SRC_D)\crypto\ecdh\ech_locl.h" "$(INCL_D)\ech_locl.h"

$(INCL_D)\ecs_locl.h: $(SRC_D)\crypto\ecdsa\ecs_locl.h
	$(CP) "$(SRC_D)\crypto\ecdsa\ecs_locl.h" "$(INCL_D)\ecs_locl.h"

$(INCL_D)\bio_lcl.h: $(SRC_D)\crypto\bio\bio_lcl.h
	$(CP) "$(SRC_D)\crypto\bio\bio_lcl.h" "$(INCL_D)\bio_lcl.h"

$(INCL_D)\obj_dat.h: $(SRC_D)\crypto\objects\obj_dat.h
	$(CP) "$(SRC_D)\crypto\objects\obj_dat.h" "$(INCL_D)\obj_dat.h"

$(INCL_D)\obj_xref.h: $(SRC_D)\crypto\objects\obj_xref.h
	$(CP) "$(SRC_D)\crypto\objects\obj_xref.h" "$(INCL_D)\obj_xref.h"

$(INCL_D)\evp_locl.h: $(SRC_D)\crypto\evp\evp_locl.h
	$(CP) "$(SRC_D)\crypto\evp\evp_locl.h" "$(INCL_D)\evp_locl.h"

$(INCL_D)\asn1_locl.h: $(SRC_D)\crypto\asn1\asn1_locl.h
	$(CP) "$(SRC_D)\crypto\asn1\asn1_locl.h" "$(INCL_D)\asn1_locl.h"

$(INCL_D)\pcy_int.h: $(SRC_D)\crypto\x509v3\pcy_int.h
	$(CP) "$(SRC_D)\crypto\x509v3\pcy_int.h" "$(INCL_D)\pcy_int.h"

$(INCL_D)\conf_def.h: $(SRC_D)\crypto\conf\conf_def.h
	$(CP) "$(SRC_D)\crypto\conf\conf_def.h" "$(INCL_D)\conf_def.h"

$(INCL_D)\ui_locl.h: $(SRC_D)\crypto\ui\ui_locl.h
	$(CP) "$(SRC_D)\crypto\ui\ui_locl.h" "$(INCL_D)\ui_locl.h"

$(INCL_D)\wp_locl.h: $(SRC_D)\crypto\whrlpool\wp_locl.h
	$(CP) "$(SRC_D)\crypto\whrlpool\wp_locl.h" "$(INCL_D)\wp_locl.h"

$(INCO_D)\e_os2.h: $(SRC_D)\.\e_os2.h
	$(CP) "$(SRC_D)\.\e_os2.h" "$(INCO_D)\e_os2.h"

$(INCO_D)\crypto.h: $(SRC_D)\crypto\crypto.h
	$(CP) "$(SRC_D)\crypto\crypto.h" "$(INCO_D)\crypto.h"

$(INCO_D)\opensslv.h: $(SRC_D)\crypto\opensslv.h
	$(CP) "$(SRC_D)\crypto\opensslv.h" "$(INCO_D)\opensslv.h"

$(INCO_D)\opensslconf.h: $(SRC_D)\crypto\opensslconf.h
	$(CP) "$(SRC_D)\crypto\opensslconf.h" "$(INCO_D)\opensslconf.h"

$(INCO_D)\ebcdic.h: $(SRC_D)\crypto\ebcdic.h
	$(CP) "$(SRC_D)\crypto\ebcdic.h" "$(INCO_D)\ebcdic.h"

$(INCO_D)\symhacks.h: $(SRC_D)\crypto\symhacks.h
	$(CP) "$(SRC_D)\crypto\symhacks.h" "$(INCO_D)\symhacks.h"

$(INCO_D)\ossl_typ.h: $(SRC_D)\crypto\ossl_typ.h
	$(CP) "$(SRC_D)\crypto\ossl_typ.h" "$(INCO_D)\ossl_typ.h"

$(INCO_D)\md4.h: $(SRC_D)\crypto\md4\md4.h
	$(CP) "$(SRC_D)\crypto\md4\md4.h" "$(INCO_D)\md4.h"

$(INCO_D)\md5.h: $(SRC_D)\crypto\md5\md5.h
	$(CP) "$(SRC_D)\crypto\md5\md5.h" "$(INCO_D)\md5.h"

$(INCO_D)\sha.h: $(SRC_D)\crypto\sha\sha.h
	$(CP) "$(SRC_D)\crypto\sha\sha.h" "$(INCO_D)\sha.h"

$(INCO_D)\md2.h: $(SRC_D)\crypto\md2\md2.h
	$(CP) "$(SRC_D)\crypto\md2\md2.h" "$(INCO_D)\md2.h"

$(INCO_D)\hmac.h: $(SRC_D)\crypto\hmac\hmac.h
	$(CP) "$(SRC_D)\crypto\hmac\hmac.h" "$(INCO_D)\hmac.h"

$(INCO_D)\cmac.h: $(SRC_D)\crypto\cmac\cmac.h
	$(CP) "$(SRC_D)\crypto\cmac\cmac.h" "$(INCO_D)\cmac.h"

$(INCO_D)\ripemd.h: $(SRC_D)\crypto\ripemd\ripemd.h
	$(CP) "$(SRC_D)\crypto\ripemd\ripemd.h" "$(INCO_D)\ripemd.h"

$(INCO_D)\des.h: $(SRC_D)\crypto\des\des.h
	$(CP) "$(SRC_D)\crypto\des\des.h" "$(INCO_D)\des.h"

$(INCO_D)\des_old.h: $(SRC_D)\crypto\des\des_old.h
	$(CP) "$(SRC_D)\crypto\des\des_old.h" "$(INCO_D)\des_old.h"

$(INCO_D)\rc2.h: $(SRC_D)\crypto\rc2\rc2.h
	$(CP) "$(SRC_D)\crypto\rc2\rc2.h" "$(INCO_D)\rc2.h"

$(INCO_D)\rc4.h: $(SRC_D)\crypto\rc4\rc4.h
	$(CP) "$(SRC_D)\crypto\rc4\rc4.h" "$(INCO_D)\rc4.h"

$(INCO_D)\idea.h: $(SRC_D)\crypto\idea\idea.h
	$(CP) "$(SRC_D)\crypto\idea\idea.h" "$(INCO_D)\idea.h"

$(INCO_D)\blowfish.h: $(SRC_D)\crypto\bf\blowfish.h
	$(CP) "$(SRC_D)\crypto\bf\blowfish.h" "$(INCO_D)\blowfish.h"

$(INCO_D)\cast.h: $(SRC_D)\crypto\cast\cast.h
	$(CP) "$(SRC_D)\crypto\cast\cast.h" "$(INCO_D)\cast.h"

$(INCO_D)\aes.h: $(SRC_D)\crypto\aes\aes.h
	$(CP) "$(SRC_D)\crypto\aes\aes.h" "$(INCO_D)\aes.h"

$(INCO_D)\modes.h: $(SRC_D)\crypto\modes\modes.h
	$(CP) "$(SRC_D)\crypto\modes\modes.h" "$(INCO_D)\modes.h"

$(INCO_D)\bn.h: $(SRC_D)\crypto\bn\bn.h
	$(CP) "$(SRC_D)\crypto\bn\bn.h" "$(INCO_D)\bn.h"

$(INCO_D)\rsa.h: $(SRC_D)\crypto\rsa\rsa.h
	$(CP) "$(SRC_D)\crypto\rsa\rsa.h" "$(INCO_D)\rsa.h"

$(INCO_D)\dsa.h: $(SRC_D)\crypto\dsa\dsa.h
	$(CP) "$(SRC_D)\crypto\dsa\dsa.h" "$(INCO_D)\dsa.h"

$(INCO_D)\dso.h: $(SRC_D)\crypto\dso\dso.h
	$(CP) "$(SRC_D)\crypto\dso\dso.h" "$(INCO_D)\dso.h"

$(INCO_D)\dh.h: $(SRC_D)\crypto\dh\dh.h
	$(CP) "$(SRC_D)\crypto\dh\dh.h" "$(INCO_D)\dh.h"

$(INCO_D)\ec.h: $(SRC_D)\crypto\ec\ec.h
	$(CP) "$(SRC_D)\crypto\ec\ec.h" "$(INCO_D)\ec.h"

$(INCO_D)\ecdh.h: $(SRC_D)\crypto\ecdh\ecdh.h
	$(CP) "$(SRC_D)\crypto\ecdh\ecdh.h" "$(INCO_D)\ecdh.h"

$(INCO_D)\ecdsa.h: $(SRC_D)\crypto\ecdsa\ecdsa.h
	$(CP) "$(SRC_D)\crypto\ecdsa\ecdsa.h" "$(INCO_D)\ecdsa.h"

$(INCO_D)\buffer.h: $(SRC_D)\crypto\buffer\buffer.h
	$(CP) "$(SRC_D)\crypto\buffer\buffer.h" "$(INCO_D)\buffer.h"

$(INCO_D)\bio.h: $(SRC_D)\crypto\bio\bio.h
	$(CP) "$(SRC_D)\crypto\bio\bio.h" "$(INCO_D)\bio.h"

$(INCO_D)\stack.h: $(SRC_D)\crypto\stack\stack.h
	$(CP) "$(SRC_D)\crypto\stack\stack.h" "$(INCO_D)\stack.h"

$(INCO_D)\safestack.h: $(SRC_D)\crypto\stack\safestack.h
	$(CP) "$(SRC_D)\crypto\stack\safestack.h" "$(INCO_D)\safestack.h"

$(INCO_D)\lhash.h: $(SRC_D)\crypto\lhash\lhash.h
	$(CP) "$(SRC_D)\crypto\lhash\lhash.h" "$(INCO_D)\lhash.h"

$(INCO_D)\rand.h: $(SRC_D)\crypto\rand\rand.h
	$(CP) "$(SRC_D)\crypto\rand\rand.h" "$(INCO_D)\rand.h"

$(INCO_D)\err.h: $(SRC_D)\crypto\err\err.h
	$(CP) "$(SRC_D)\crypto\err\err.h" "$(INCO_D)\err.h"

$(INCO_D)\objects.h: $(SRC_D)\crypto\objects\objects.h
	$(CP) "$(SRC_D)\crypto\objects\objects.h" "$(INCO_D)\objects.h"

$(INCO_D)\obj_mac.h: $(SRC_D)\crypto\objects\obj_mac.h
	$(CP) "$(SRC_D)\crypto\objects\obj_mac.h" "$(INCO_D)\obj_mac.h"

$(INCO_D)\evp.h: $(SRC_D)\crypto\evp\evp.h
	$(CP) "$(SRC_D)\crypto\evp\evp.h" "$(INCO_D)\evp.h"

$(INCO_D)\asn1.h: $(SRC_D)\crypto\asn1\asn1.h
	$(CP) "$(SRC_D)\crypto\asn1\asn1.h" "$(INCO_D)\asn1.h"

$(INCO_D)\asn1_mac.h: $(SRC_D)\crypto\asn1\asn1_mac.h
	$(CP) "$(SRC_D)\crypto\asn1\asn1_mac.h" "$(INCO_D)\asn1_mac.h"

$(INCO_D)\asn1t.h: $(SRC_D)\crypto\asn1\asn1t.h
	$(CP) "$(SRC_D)\crypto\asn1\asn1t.h" "$(INCO_D)\asn1t.h"

$(INCO_D)\pem.h: $(SRC_D)\crypto\pem\pem.h
	$(CP) "$(SRC_D)\crypto\pem\pem.h" "$(INCO_D)\pem.h"

$(INCO_D)\pem2.h: $(SRC_D)\crypto\pem\pem2.h
	$(CP) "$(SRC_D)\crypto\pem\pem2.h" "$(INCO_D)\pem2.h"

$(INCO_D)\x509.h: $(SRC_D)\crypto\x509\x509.h
	$(CP) "$(SRC_D)\crypto\x509\x509.h" "$(INCO_D)\x509.h"

$(INCO_D)\x509_vfy.h: $(SRC_D)\crypto\x509\x509_vfy.h
	$(CP) "$(SRC_D)\crypto\x509\x509_vfy.h" "$(INCO_D)\x509_vfy.h"

$(INCO_D)\x509v3.h: $(SRC_D)\crypto\x509v3\x509v3.h
	$(CP) "$(SRC_D)\crypto\x509v3\x509v3.h" "$(INCO_D)\x509v3.h"

$(INCO_D)\conf.h: $(SRC_D)\crypto\conf\conf.h
	$(CP) "$(SRC_D)\crypto\conf\conf.h" "$(INCO_D)\conf.h"

$(INCO_D)\conf_api.h: $(SRC_D)\crypto\conf\conf_api.h
	$(CP) "$(SRC_D)\crypto\conf\conf_api.h" "$(INCO_D)\conf_api.h"

$(INCO_D)\txt_db.h: $(SRC_D)\crypto\txt_db\txt_db.h
	$(CP) "$(SRC_D)\crypto\txt_db\txt_db.h" "$(INCO_D)\txt_db.h"

$(INCO_D)\pkcs7.h: $(SRC_D)\crypto\pkcs7\pkcs7.h
	$(CP) "$(SRC_D)\crypto\pkcs7\pkcs7.h" "$(INCO_D)\pkcs7.h"

$(INCO_D)\pkcs12.h: $(SRC_D)\crypto\pkcs12\pkcs12.h
	$(CP) "$(SRC_D)\crypto\pkcs12\pkcs12.h" "$(INCO_D)\pkcs12.h"

$(INCO_D)\comp.h: $(SRC_D)\crypto\comp\comp.h
	$(CP) "$(SRC_D)\crypto\comp\comp.h" "$(INCO_D)\comp.h"

$(INCO_D)\engine.h: $(SRC_D)\crypto\engine\engine.h
	$(CP) "$(SRC_D)\crypto\engine\engine.h" "$(INCO_D)\engine.h"

$(INCO_D)\ocsp.h: $(SRC_D)\crypto\ocsp\ocsp.h
	$(CP) "$(SRC_D)\crypto\ocsp\ocsp.h" "$(INCO_D)\ocsp.h"

$(INCO_D)\ui.h: $(SRC_D)\crypto\ui\ui.h
	$(CP) "$(SRC_D)\crypto\ui\ui.h" "$(INCO_D)\ui.h"

$(INCO_D)\ui_compat.h: $(SRC_D)\crypto\ui\ui_compat.h
	$(CP) "$(SRC_D)\crypto\ui\ui_compat.h" "$(INCO_D)\ui_compat.h"

$(INCO_D)\krb5_asn.h: $(SRC_D)\crypto\krb5\krb5_asn.h
	$(CP) "$(SRC_D)\crypto\krb5\krb5_asn.h" "$(INCO_D)\krb5_asn.h"

$(INCO_D)\pqueue.h: $(SRC_D)\crypto\pqueue\pqueue.h
	$(CP) "$(SRC_D)\crypto\pqueue\pqueue.h" "$(INCO_D)\pqueue.h"

$(INCO_D)\whrlpool.h: $(SRC_D)\crypto\whrlpool\whrlpool.h
	$(CP) "$(SRC_D)\crypto\whrlpool\whrlpool.h" "$(INCO_D)\whrlpool.h"

$(INCO_D)\ts.h: $(SRC_D)\crypto\ts\ts.h
	$(CP) "$(SRC_D)\crypto\ts\ts.h" "$(INCO_D)\ts.h"

$(INCO_D)\srp.h: $(SRC_D)\crypto\srp\srp.h
	$(CP) "$(SRC_D)\crypto\srp\srp.h" "$(INCO_D)\srp.h"

$(OBJ_D)\md4test.obj: $(SRC_D)\crypto\md4\md4test.c
	$(CC) /Fo$(OBJ_D)\md4test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\md4\md4test.c

$(OBJ_D)\md5test.obj: $(SRC_D)\crypto\md5\md5test.c
	$(CC) /Fo$(OBJ_D)\md5test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\md5\md5test.c

$(OBJ_D)\shatest.obj: $(SRC_D)\crypto\sha\shatest.c
	$(CC) /Fo$(OBJ_D)\shatest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\sha\shatest.c

$(OBJ_D)\sha1test.obj: $(SRC_D)\crypto\sha\sha1test.c
	$(CC) /Fo$(OBJ_D)\sha1test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\sha\sha1test.c

$(OBJ_D)\sha256t.obj: $(SRC_D)\crypto\sha\sha256t.c
	$(CC) /Fo$(OBJ_D)\sha256t.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\sha\sha256t.c

$(OBJ_D)\sha512t.obj: $(SRC_D)\crypto\sha\sha512t.c
	$(CC) /Fo$(OBJ_D)\sha512t.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\sha\sha512t.c

$(OBJ_D)\md2test.obj: $(SRC_D)\crypto\md2\md2test.c
	$(CC) /Fo$(OBJ_D)\md2test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\md2\md2test.c

$(OBJ_D)\hmactest.obj: $(SRC_D)\crypto\hmac\hmactest.c
	$(CC) /Fo$(OBJ_D)\hmactest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\hmac\hmactest.c

$(OBJ_D)\rmdtest.obj: $(SRC_D)\crypto\ripemd\rmdtest.c
	$(CC) /Fo$(OBJ_D)\rmdtest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\ripemd\rmdtest.c

$(OBJ_D)\destest.obj: $(SRC_D)\crypto\des\destest.c
	$(CC) /Fo$(OBJ_D)\destest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\des\destest.c

$(OBJ_D)\rc2test.obj: $(SRC_D)\crypto\rc2\rc2test.c
	$(CC) /Fo$(OBJ_D)\rc2test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\rc2\rc2test.c

$(OBJ_D)\rc4test.obj: $(SRC_D)\crypto\rc4\rc4test.c
	$(CC) /Fo$(OBJ_D)\rc4test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\rc4\rc4test.c

$(OBJ_D)\ideatest.obj: $(SRC_D)\crypto\idea\ideatest.c
	$(CC) /Fo$(OBJ_D)\ideatest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\idea\ideatest.c

$(OBJ_D)\bftest.obj: $(SRC_D)\crypto\bf\bftest.c
	$(CC) /Fo$(OBJ_D)\bftest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\bf\bftest.c

$(OBJ_D)\casttest.obj: $(SRC_D)\crypto\cast\casttest.c
	$(CC) /Fo$(OBJ_D)\casttest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\cast\casttest.c

$(OBJ_D)\bntest.obj: $(SRC_D)\crypto\bn\bntest.c
	$(CC) /Fo$(OBJ_D)\bntest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\bn\bntest.c

$(OBJ_D)\exptest.obj: $(SRC_D)\crypto\bn\exptest.c
	$(CC) /Fo$(OBJ_D)\exptest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\bn\exptest.c

$(OBJ_D)\rsa_test.obj: $(SRC_D)\crypto\rsa\rsa_test.c
	$(CC) /Fo$(OBJ_D)\rsa_test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_test.c

$(OBJ_D)\dsatest.obj: $(SRC_D)\crypto\dsa\dsatest.c
	$(CC) /Fo$(OBJ_D)\dsatest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\dsa\dsatest.c

$(OBJ_D)\dhtest.obj: $(SRC_D)\crypto\dh\dhtest.c
	$(CC) /Fo$(OBJ_D)\dhtest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\dh\dhtest.c

$(OBJ_D)\ectest.obj: $(SRC_D)\crypto\ec\ectest.c
	$(CC) /Fo$(OBJ_D)\ectest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\ec\ectest.c

$(OBJ_D)\ecdhtest.obj: $(SRC_D)\crypto\ecdh\ecdhtest.c
	$(CC) /Fo$(OBJ_D)\ecdhtest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\ecdh\ecdhtest.c

$(OBJ_D)\ecdsatest.obj: $(SRC_D)\crypto\ecdsa\ecdsatest.c
	$(CC) /Fo$(OBJ_D)\ecdsatest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\ecdsa\ecdsatest.c

$(OBJ_D)\randtest.obj: $(SRC_D)\crypto\rand\randtest.c
	$(CC) /Fo$(OBJ_D)\randtest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\rand\randtest.c

$(OBJ_D)\evp_test.obj: $(SRC_D)\crypto\evp\evp_test.c
	$(CC) /Fo$(OBJ_D)\evp_test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\evp\evp_test.c

$(OBJ_D)\enginetest.obj: $(SRC_D)\crypto\engine\enginetest.c
	$(CC) /Fo$(OBJ_D)\enginetest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\engine\enginetest.c

$(OBJ_D)\wp_test.obj: $(SRC_D)\crypto\whrlpool\wp_test.c
	$(CC) /Fo$(OBJ_D)\wp_test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\whrlpool\wp_test.c

$(OBJ_D)\srptest.obj: $(SRC_D)\crypto\srp\srptest.c
	$(CC) /Fo$(OBJ_D)\srptest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\srp\srptest.c

$(OBJ_D)\cryptlib.obj: $(SRC_D)\crypto\cryptlib.c
	$(CC) /Fo$(OBJ_D)\cryptlib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\cryptlib.c

$(OBJ_D)\mem.obj: $(SRC_D)\crypto\mem.c
	$(CC) /Fo$(OBJ_D)\mem.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\mem.c

$(OBJ_D)\mem_dbg.obj: $(SRC_D)\crypto\mem_dbg.c
	$(CC) /Fo$(OBJ_D)\mem_dbg.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\mem_dbg.c

$(OBJ_D)\cversion.obj: $(SRC_D)\crypto\cversion.c
	$(CC) /Fo$(OBJ_D)\cversion.obj  $(LIB_CFLAGS) -DMK1MF_BUILD -DMK1MF_PLATFORM_VC_WIN32 -c $(SRC_D)\crypto\cversion.c

$(OBJ_D)\ex_data.obj: $(SRC_D)\crypto\ex_data.c
	$(CC) /Fo$(OBJ_D)\ex_data.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ex_data.c

$(OBJ_D)\cpt_err.obj: $(SRC_D)\crypto\cpt_err.c
	$(CC) /Fo$(OBJ_D)\cpt_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\cpt_err.c

$(OBJ_D)\ebcdic.obj: $(SRC_D)\crypto\ebcdic.c
	$(CC) /Fo$(OBJ_D)\ebcdic.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ebcdic.c

$(OBJ_D)\uid.obj: $(SRC_D)\crypto\uid.c
	$(CC) /Fo$(OBJ_D)\uid.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\uid.c

$(OBJ_D)\o_time.obj: $(SRC_D)\crypto\o_time.c
	$(CC) /Fo$(OBJ_D)\o_time.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\o_time.c

$(OBJ_D)\o_str.obj: $(SRC_D)\crypto\o_str.c
	$(CC) /Fo$(OBJ_D)\o_str.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\o_str.c

$(OBJ_D)\o_dir.obj: $(SRC_D)\crypto\o_dir.c
	$(CC) /Fo$(OBJ_D)\o_dir.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\o_dir.c

$(OBJ_D)\o_fips.obj: $(SRC_D)\crypto\o_fips.c
	$(CC) /Fo$(OBJ_D)\o_fips.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\o_fips.c

$(OBJ_D)\o_init.obj: $(SRC_D)\crypto\o_init.c
	$(CC) /Fo$(OBJ_D)\o_init.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\o_init.c

$(TMP_D)\x86cpuid.asm: crypto\x86cpuid.pl
	$(PERL) crypto\x86cpuid.pl win32 $(CFLAG) >$@

$(OBJ_D)\x86cpuid.obj: $(TMP_D)\x86cpuid.asm
	$(ASM) /Fo$@ $(TMP_D)\x86cpuid.asm

$(OBJ_D)\md4_dgst.obj: $(SRC_D)\crypto\md4\md4_dgst.c
	$(CC) /Fo$(OBJ_D)\md4_dgst.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\md4\md4_dgst.c

$(OBJ_D)\md4_one.obj: $(SRC_D)\crypto\md4\md4_one.c
	$(CC) /Fo$(OBJ_D)\md4_one.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\md4\md4_one.c

$(OBJ_D)\md5_dgst.obj: $(SRC_D)\crypto\md5\md5_dgst.c
	$(CC) /Fo$(OBJ_D)\md5_dgst.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\md5\md5_dgst.c

$(OBJ_D)\md5_one.obj: $(SRC_D)\crypto\md5\md5_one.c
	$(CC) /Fo$(OBJ_D)\md5_one.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\md5\md5_one.c

$(TMP_D)\md5-586.asm: crypto\md5\asm\md5-586.pl
	$(PERL) crypto\md5\asm\md5-586.pl win32 $(CFLAG) >$@

$(OBJ_D)\md5-586.obj: $(TMP_D)\md5-586.asm
	$(ASM) /Fo$@ $(TMP_D)\md5-586.asm

$(OBJ_D)\sha_dgst.obj: $(SRC_D)\crypto\sha\sha_dgst.c
	$(CC) /Fo$(OBJ_D)\sha_dgst.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\sha\sha_dgst.c

$(OBJ_D)\sha1dgst.obj: $(SRC_D)\crypto\sha\sha1dgst.c
	$(CC) /Fo$(OBJ_D)\sha1dgst.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\sha\sha1dgst.c

$(OBJ_D)\sha_one.obj: $(SRC_D)\crypto\sha\sha_one.c
	$(CC) /Fo$(OBJ_D)\sha_one.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\sha\sha_one.c

$(OBJ_D)\sha1_one.obj: $(SRC_D)\crypto\sha\sha1_one.c
	$(CC) /Fo$(OBJ_D)\sha1_one.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\sha\sha1_one.c

$(OBJ_D)\sha256.obj: $(SRC_D)\crypto\sha\sha256.c
	$(CC) /Fo$(OBJ_D)\sha256.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\sha\sha256.c

$(OBJ_D)\sha512.obj: $(SRC_D)\crypto\sha\sha512.c
	$(CC) /Fo$(OBJ_D)\sha512.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\sha\sha512.c

$(TMP_D)\sha1-586.asm: crypto\sha\asm\sha1-586.pl
	$(PERL) crypto\sha\asm\sha1-586.pl win32 $(CFLAG) >$@

$(OBJ_D)\sha1-586.obj: $(TMP_D)\sha1-586.asm
	$(ASM) /Fo$@ $(TMP_D)\sha1-586.asm

$(TMP_D)\sha256-586.asm: crypto\sha\asm\sha256-586.pl
	$(PERL) crypto\sha\asm\sha256-586.pl win32 $(CFLAG) >$@

$(OBJ_D)\sha256-586.obj: $(TMP_D)\sha256-586.asm
	$(ASM) /Fo$@ $(TMP_D)\sha256-586.asm

$(TMP_D)\sha512-586.asm: crypto\sha\asm\sha512-586.pl
	$(PERL) crypto\sha\asm\sha512-586.pl win32 $(CFLAG) >$@

$(OBJ_D)\sha512-586.obj: $(TMP_D)\sha512-586.asm
	$(ASM) /Fo$@ $(TMP_D)\sha512-586.asm

$(OBJ_D)\md2_dgst.obj: $(SRC_D)\crypto\md2\md2_dgst.c
	$(CC) /Fo$(OBJ_D)\md2_dgst.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\md2\md2_dgst.c

$(OBJ_D)\md2_one.obj: $(SRC_D)\crypto\md2\md2_one.c
	$(CC) /Fo$(OBJ_D)\md2_one.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\md2\md2_one.c

$(OBJ_D)\hmac.obj: $(SRC_D)\crypto\hmac\hmac.c
	$(CC) /Fo$(OBJ_D)\hmac.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\hmac\hmac.c

$(OBJ_D)\hm_ameth.obj: $(SRC_D)\crypto\hmac\hm_ameth.c
	$(CC) /Fo$(OBJ_D)\hm_ameth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\hmac\hm_ameth.c

$(OBJ_D)\hm_pmeth.obj: $(SRC_D)\crypto\hmac\hm_pmeth.c
	$(CC) /Fo$(OBJ_D)\hm_pmeth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\hmac\hm_pmeth.c

$(OBJ_D)\cmac.obj: $(SRC_D)\crypto\cmac\cmac.c
	$(CC) /Fo$(OBJ_D)\cmac.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\cmac\cmac.c

$(OBJ_D)\cm_ameth.obj: $(SRC_D)\crypto\cmac\cm_ameth.c
	$(CC) /Fo$(OBJ_D)\cm_ameth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\cmac\cm_ameth.c

$(OBJ_D)\cm_pmeth.obj: $(SRC_D)\crypto\cmac\cm_pmeth.c
	$(CC) /Fo$(OBJ_D)\cm_pmeth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\cmac\cm_pmeth.c

$(OBJ_D)\rmd_dgst.obj: $(SRC_D)\crypto\ripemd\rmd_dgst.c
	$(CC) /Fo$(OBJ_D)\rmd_dgst.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ripemd\rmd_dgst.c

$(OBJ_D)\rmd_one.obj: $(SRC_D)\crypto\ripemd\rmd_one.c
	$(CC) /Fo$(OBJ_D)\rmd_one.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ripemd\rmd_one.c

$(TMP_D)\rmd-586.asm: crypto\ripemd\asm\rmd-586.pl
	$(PERL) crypto\ripemd\asm\rmd-586.pl win32 $(CFLAG) >$@

$(OBJ_D)\rmd-586.obj: $(TMP_D)\rmd-586.asm
	$(ASM) /Fo$@ $(TMP_D)\rmd-586.asm

$(OBJ_D)\set_key.obj: $(SRC_D)\crypto\des\set_key.c
	$(CC) /Fo$(OBJ_D)\set_key.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\set_key.c

$(OBJ_D)\ecb_enc.obj: $(SRC_D)\crypto\des\ecb_enc.c
	$(CC) /Fo$(OBJ_D)\ecb_enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\ecb_enc.c

$(OBJ_D)\cbc_enc.obj: $(SRC_D)\crypto\des\cbc_enc.c
	$(CC) /Fo$(OBJ_D)\cbc_enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\cbc_enc.c

$(OBJ_D)\ecb3_enc.obj: $(SRC_D)\crypto\des\ecb3_enc.c
	$(CC) /Fo$(OBJ_D)\ecb3_enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\ecb3_enc.c

$(OBJ_D)\cfb64enc.obj: $(SRC_D)\crypto\des\cfb64enc.c
	$(CC) /Fo$(OBJ_D)\cfb64enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\cfb64enc.c

$(OBJ_D)\cfb64ede.obj: $(SRC_D)\crypto\des\cfb64ede.c
	$(CC) /Fo$(OBJ_D)\cfb64ede.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\cfb64ede.c

$(OBJ_D)\cfb_enc.obj: $(SRC_D)\crypto\des\cfb_enc.c
	$(CC) /Fo$(OBJ_D)\cfb_enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\cfb_enc.c

$(OBJ_D)\ofb64ede.obj: $(SRC_D)\crypto\des\ofb64ede.c
	$(CC) /Fo$(OBJ_D)\ofb64ede.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\ofb64ede.c

$(OBJ_D)\enc_read.obj: $(SRC_D)\crypto\des\enc_read.c
	$(CC) /Fo$(OBJ_D)\enc_read.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\enc_read.c

$(OBJ_D)\enc_writ.obj: $(SRC_D)\crypto\des\enc_writ.c
	$(CC) /Fo$(OBJ_D)\enc_writ.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\enc_writ.c

$(OBJ_D)\ofb64enc.obj: $(SRC_D)\crypto\des\ofb64enc.c
	$(CC) /Fo$(OBJ_D)\ofb64enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\ofb64enc.c

$(OBJ_D)\ofb_enc.obj: $(SRC_D)\crypto\des\ofb_enc.c
	$(CC) /Fo$(OBJ_D)\ofb_enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\ofb_enc.c

$(OBJ_D)\str2key.obj: $(SRC_D)\crypto\des\str2key.c
	$(CC) /Fo$(OBJ_D)\str2key.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\str2key.c

$(OBJ_D)\pcbc_enc.obj: $(SRC_D)\crypto\des\pcbc_enc.c
	$(CC) /Fo$(OBJ_D)\pcbc_enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\pcbc_enc.c

$(OBJ_D)\qud_cksm.obj: $(SRC_D)\crypto\des\qud_cksm.c
	$(CC) /Fo$(OBJ_D)\qud_cksm.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\qud_cksm.c

$(OBJ_D)\rand_key.obj: $(SRC_D)\crypto\des\rand_key.c
	$(CC) /Fo$(OBJ_D)\rand_key.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\rand_key.c

$(TMP_D)\des-586.asm: crypto\des\asm\des-586.pl
	$(PERL) crypto\des\asm\des-586.pl win32 $(CFLAG) >$@

$(OBJ_D)\des-586.obj: $(TMP_D)\des-586.asm
	$(ASM) /Fo$@ $(TMP_D)\des-586.asm

$(TMP_D)\crypt586.asm: crypto\des\asm\crypt586.pl
	$(PERL) crypto\des\asm\crypt586.pl win32 $(CFLAG) >$@

$(OBJ_D)\crypt586.obj: $(TMP_D)\crypt586.asm
	$(ASM) /Fo$@ $(TMP_D)\crypt586.asm

$(OBJ_D)\fcrypt.obj: $(SRC_D)\crypto\des\fcrypt.c
	$(CC) /Fo$(OBJ_D)\fcrypt.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\fcrypt.c

$(OBJ_D)\xcbc_enc.obj: $(SRC_D)\crypto\des\xcbc_enc.c
	$(CC) /Fo$(OBJ_D)\xcbc_enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\xcbc_enc.c

$(OBJ_D)\rpc_enc.obj: $(SRC_D)\crypto\des\rpc_enc.c
	$(CC) /Fo$(OBJ_D)\rpc_enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\rpc_enc.c

$(OBJ_D)\cbc_cksm.obj: $(SRC_D)\crypto\des\cbc_cksm.c
	$(CC) /Fo$(OBJ_D)\cbc_cksm.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\cbc_cksm.c

$(OBJ_D)\ede_cbcm_enc.obj: $(SRC_D)\crypto\des\ede_cbcm_enc.c
	$(CC) /Fo$(OBJ_D)\ede_cbcm_enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\ede_cbcm_enc.c

$(OBJ_D)\des_old.obj: $(SRC_D)\crypto\des\des_old.c
	$(CC) /Fo$(OBJ_D)\des_old.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\des_old.c

$(OBJ_D)\des_old2.obj: $(SRC_D)\crypto\des\des_old2.c
	$(CC) /Fo$(OBJ_D)\des_old2.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\des_old2.c

$(OBJ_D)\read2pwd.obj: $(SRC_D)\crypto\des\read2pwd.c
	$(CC) /Fo$(OBJ_D)\read2pwd.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\des\read2pwd.c

$(OBJ_D)\rc2_ecb.obj: $(SRC_D)\crypto\rc2\rc2_ecb.c
	$(CC) /Fo$(OBJ_D)\rc2_ecb.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rc2\rc2_ecb.c

$(OBJ_D)\rc2_skey.obj: $(SRC_D)\crypto\rc2\rc2_skey.c
	$(CC) /Fo$(OBJ_D)\rc2_skey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rc2\rc2_skey.c

$(OBJ_D)\rc2_cbc.obj: $(SRC_D)\crypto\rc2\rc2_cbc.c
	$(CC) /Fo$(OBJ_D)\rc2_cbc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rc2\rc2_cbc.c

$(OBJ_D)\rc2cfb64.obj: $(SRC_D)\crypto\rc2\rc2cfb64.c
	$(CC) /Fo$(OBJ_D)\rc2cfb64.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rc2\rc2cfb64.c

$(OBJ_D)\rc2ofb64.obj: $(SRC_D)\crypto\rc2\rc2ofb64.c
	$(CC) /Fo$(OBJ_D)\rc2ofb64.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rc2\rc2ofb64.c

$(TMP_D)\rc4-586.asm: crypto\rc4\asm\rc4-586.pl
	$(PERL) crypto\rc4\asm\rc4-586.pl win32 $(CFLAG) >$@

$(OBJ_D)\rc4-586.obj: $(TMP_D)\rc4-586.asm
	$(ASM) /Fo$@ $(TMP_D)\rc4-586.asm

$(OBJ_D)\rc4_utl.obj: $(SRC_D)\crypto\rc4\rc4_utl.c
	$(CC) /Fo$(OBJ_D)\rc4_utl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rc4\rc4_utl.c

$(OBJ_D)\i_cbc.obj: $(SRC_D)\crypto\idea\i_cbc.c
	$(CC) /Fo$(OBJ_D)\i_cbc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\idea\i_cbc.c

$(OBJ_D)\i_cfb64.obj: $(SRC_D)\crypto\idea\i_cfb64.c
	$(CC) /Fo$(OBJ_D)\i_cfb64.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\idea\i_cfb64.c

$(OBJ_D)\i_ofb64.obj: $(SRC_D)\crypto\idea\i_ofb64.c
	$(CC) /Fo$(OBJ_D)\i_ofb64.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\idea\i_ofb64.c

$(OBJ_D)\i_ecb.obj: $(SRC_D)\crypto\idea\i_ecb.c
	$(CC) /Fo$(OBJ_D)\i_ecb.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\idea\i_ecb.c

$(OBJ_D)\i_skey.obj: $(SRC_D)\crypto\idea\i_skey.c
	$(CC) /Fo$(OBJ_D)\i_skey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\idea\i_skey.c

$(OBJ_D)\bf_skey.obj: $(SRC_D)\crypto\bf\bf_skey.c
	$(CC) /Fo$(OBJ_D)\bf_skey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bf\bf_skey.c

$(OBJ_D)\bf_ecb.obj: $(SRC_D)\crypto\bf\bf_ecb.c
	$(CC) /Fo$(OBJ_D)\bf_ecb.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bf\bf_ecb.c

$(TMP_D)\bf-586.asm: crypto\bf\asm\bf-586.pl
	$(PERL) crypto\bf\asm\bf-586.pl win32 $(CFLAG) >$@

$(OBJ_D)\bf-586.obj: $(TMP_D)\bf-586.asm
	$(ASM) /Fo$@ $(TMP_D)\bf-586.asm

$(OBJ_D)\bf_cfb64.obj: $(SRC_D)\crypto\bf\bf_cfb64.c
	$(CC) /Fo$(OBJ_D)\bf_cfb64.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bf\bf_cfb64.c

$(OBJ_D)\bf_ofb64.obj: $(SRC_D)\crypto\bf\bf_ofb64.c
	$(CC) /Fo$(OBJ_D)\bf_ofb64.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bf\bf_ofb64.c

$(OBJ_D)\c_skey.obj: $(SRC_D)\crypto\cast\c_skey.c
	$(CC) /Fo$(OBJ_D)\c_skey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\cast\c_skey.c

$(OBJ_D)\c_ecb.obj: $(SRC_D)\crypto\cast\c_ecb.c
	$(CC) /Fo$(OBJ_D)\c_ecb.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\cast\c_ecb.c

$(TMP_D)\cast-586.asm: crypto\cast\asm\cast-586.pl
	$(PERL) crypto\cast\asm\cast-586.pl win32 $(CFLAG) >$@

$(OBJ_D)\cast-586.obj: $(TMP_D)\cast-586.asm
	$(ASM) /Fo$@ $(TMP_D)\cast-586.asm

$(OBJ_D)\c_cfb64.obj: $(SRC_D)\crypto\cast\c_cfb64.c
	$(CC) /Fo$(OBJ_D)\c_cfb64.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\cast\c_cfb64.c

$(OBJ_D)\c_ofb64.obj: $(SRC_D)\crypto\cast\c_ofb64.c
	$(CC) /Fo$(OBJ_D)\c_ofb64.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\cast\c_ofb64.c

$(OBJ_D)\aes_misc.obj: $(SRC_D)\crypto\aes\aes_misc.c
	$(CC) /Fo$(OBJ_D)\aes_misc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\aes\aes_misc.c

$(OBJ_D)\aes_ecb.obj: $(SRC_D)\crypto\aes\aes_ecb.c
	$(CC) /Fo$(OBJ_D)\aes_ecb.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\aes\aes_ecb.c

$(OBJ_D)\aes_cfb.obj: $(SRC_D)\crypto\aes\aes_cfb.c
	$(CC) /Fo$(OBJ_D)\aes_cfb.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\aes\aes_cfb.c

$(OBJ_D)\aes_ofb.obj: $(SRC_D)\crypto\aes\aes_ofb.c
	$(CC) /Fo$(OBJ_D)\aes_ofb.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\aes\aes_ofb.c

$(OBJ_D)\aes_ctr.obj: $(SRC_D)\crypto\aes\aes_ctr.c
	$(CC) /Fo$(OBJ_D)\aes_ctr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\aes\aes_ctr.c

$(OBJ_D)\aes_ige.obj: $(SRC_D)\crypto\aes\aes_ige.c
	$(CC) /Fo$(OBJ_D)\aes_ige.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\aes\aes_ige.c

$(OBJ_D)\aes_wrap.obj: $(SRC_D)\crypto\aes\aes_wrap.c
	$(CC) /Fo$(OBJ_D)\aes_wrap.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\aes\aes_wrap.c

$(TMP_D)\aes-586.asm: crypto\aes\asm\aes-586.pl
	$(PERL) crypto\aes\asm\aes-586.pl win32 $(CFLAG) >$@

$(OBJ_D)\aes-586.obj: $(TMP_D)\aes-586.asm
	$(ASM) /Fo$@ $(TMP_D)\aes-586.asm

$(TMP_D)\vpaes-x86.asm: crypto\aes\asm\vpaes-x86.pl
	$(PERL) crypto\aes\asm\vpaes-x86.pl win32 $(CFLAG) >$@

$(OBJ_D)\vpaes-x86.obj: $(TMP_D)\vpaes-x86.asm
	$(ASM) /Fo$@ $(TMP_D)\vpaes-x86.asm

$(TMP_D)\aesni-x86.asm: crypto\aes\asm\aesni-x86.pl
	$(PERL) crypto\aes\asm\aesni-x86.pl win32 $(CFLAG) >$@

$(OBJ_D)\aesni-x86.obj: $(TMP_D)\aesni-x86.asm
	$(ASM) /Fo$@ $(TMP_D)\aesni-x86.asm

$(OBJ_D)\cbc128.obj: $(SRC_D)\crypto\modes\cbc128.c
	$(CC) /Fo$(OBJ_D)\cbc128.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\modes\cbc128.c

$(OBJ_D)\ctr128.obj: $(SRC_D)\crypto\modes\ctr128.c
	$(CC) /Fo$(OBJ_D)\ctr128.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\modes\ctr128.c

$(OBJ_D)\cts128.obj: $(SRC_D)\crypto\modes\cts128.c
	$(CC) /Fo$(OBJ_D)\cts128.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\modes\cts128.c

$(OBJ_D)\cfb128.obj: $(SRC_D)\crypto\modes\cfb128.c
	$(CC) /Fo$(OBJ_D)\cfb128.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\modes\cfb128.c

$(OBJ_D)\ofb128.obj: $(SRC_D)\crypto\modes\ofb128.c
	$(CC) /Fo$(OBJ_D)\ofb128.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\modes\ofb128.c

$(OBJ_D)\gcm128.obj: $(SRC_D)\crypto\modes\gcm128.c
	$(CC) /Fo$(OBJ_D)\gcm128.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\modes\gcm128.c

$(OBJ_D)\ccm128.obj: $(SRC_D)\crypto\modes\ccm128.c
	$(CC) /Fo$(OBJ_D)\ccm128.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\modes\ccm128.c

$(OBJ_D)\xts128.obj: $(SRC_D)\crypto\modes\xts128.c
	$(CC) /Fo$(OBJ_D)\xts128.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\modes\xts128.c

$(TMP_D)\ghash-x86.asm: crypto\modes\asm\ghash-x86.pl
	$(PERL) crypto\modes\asm\ghash-x86.pl win32 $(CFLAG) >$@

$(OBJ_D)\ghash-x86.obj: $(TMP_D)\ghash-x86.asm
	$(ASM) /Fo$@ $(TMP_D)\ghash-x86.asm

$(OBJ_D)\bn_add.obj: $(SRC_D)\crypto\bn\bn_add.c
	$(CC) /Fo$(OBJ_D)\bn_add.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_add.c

$(OBJ_D)\bn_div.obj: $(SRC_D)\crypto\bn\bn_div.c
	$(CC) /Fo$(OBJ_D)\bn_div.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_div.c

$(OBJ_D)\bn_exp.obj: $(SRC_D)\crypto\bn\bn_exp.c
	$(CC) /Fo$(OBJ_D)\bn_exp.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_exp.c

$(OBJ_D)\bn_lib.obj: $(SRC_D)\crypto\bn\bn_lib.c
	$(CC) /Fo$(OBJ_D)\bn_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_lib.c

$(OBJ_D)\bn_ctx.obj: $(SRC_D)\crypto\bn\bn_ctx.c
	$(CC) /Fo$(OBJ_D)\bn_ctx.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_ctx.c

$(OBJ_D)\bn_mul.obj: $(SRC_D)\crypto\bn\bn_mul.c
	$(CC) /Fo$(OBJ_D)\bn_mul.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_mul.c

$(OBJ_D)\bn_mod.obj: $(SRC_D)\crypto\bn\bn_mod.c
	$(CC) /Fo$(OBJ_D)\bn_mod.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_mod.c

$(OBJ_D)\bn_print.obj: $(SRC_D)\crypto\bn\bn_print.c
	$(CC) /Fo$(OBJ_D)\bn_print.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_print.c

$(OBJ_D)\bn_rand.obj: $(SRC_D)\crypto\bn\bn_rand.c
	$(CC) /Fo$(OBJ_D)\bn_rand.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_rand.c

$(OBJ_D)\bn_shift.obj: $(SRC_D)\crypto\bn\bn_shift.c
	$(CC) /Fo$(OBJ_D)\bn_shift.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_shift.c

$(OBJ_D)\bn_word.obj: $(SRC_D)\crypto\bn\bn_word.c
	$(CC) /Fo$(OBJ_D)\bn_word.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_word.c

$(OBJ_D)\bn_blind.obj: $(SRC_D)\crypto\bn\bn_blind.c
	$(CC) /Fo$(OBJ_D)\bn_blind.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_blind.c

$(OBJ_D)\bn_kron.obj: $(SRC_D)\crypto\bn\bn_kron.c
	$(CC) /Fo$(OBJ_D)\bn_kron.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_kron.c

$(OBJ_D)\bn_sqrt.obj: $(SRC_D)\crypto\bn\bn_sqrt.c
	$(CC) /Fo$(OBJ_D)\bn_sqrt.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_sqrt.c

$(OBJ_D)\bn_gcd.obj: $(SRC_D)\crypto\bn\bn_gcd.c
	$(CC) /Fo$(OBJ_D)\bn_gcd.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_gcd.c

$(OBJ_D)\bn_prime.obj: $(SRC_D)\crypto\bn\bn_prime.c
	$(CC) /Fo$(OBJ_D)\bn_prime.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_prime.c

$(OBJ_D)\bn_err.obj: $(SRC_D)\crypto\bn\bn_err.c
	$(CC) /Fo$(OBJ_D)\bn_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_err.c

$(OBJ_D)\bn_sqr.obj: $(SRC_D)\crypto\bn\bn_sqr.c
	$(CC) /Fo$(OBJ_D)\bn_sqr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_sqr.c

$(TMP_D)\bn-586.asm: crypto\bn\asm\bn-586.pl
	$(PERL) crypto\bn\asm\bn-586.pl win32 $(CFLAG) >$@

$(OBJ_D)\bn-586.obj: $(TMP_D)\bn-586.asm
	$(ASM) /Fo$@ $(TMP_D)\bn-586.asm

$(TMP_D)\co-586.asm: crypto\bn\asm\co-586.pl
	$(PERL) crypto\bn\asm\co-586.pl win32 $(CFLAG) >$@

$(OBJ_D)\co-586.obj: $(TMP_D)\co-586.asm
	$(ASM) /Fo$@ $(TMP_D)\co-586.asm

$(TMP_D)\x86-mont.asm: crypto\bn\asm\x86-mont.pl
	$(PERL) crypto\bn\asm\x86-mont.pl win32 $(CFLAG) >$@

$(OBJ_D)\x86-mont.obj: $(TMP_D)\x86-mont.asm
	$(ASM) /Fo$@ $(TMP_D)\x86-mont.asm

$(TMP_D)\x86-gf2m.asm: crypto\bn\asm\x86-gf2m.pl
	$(PERL) crypto\bn\asm\x86-gf2m.pl win32 $(CFLAG) >$@

$(OBJ_D)\x86-gf2m.obj: $(TMP_D)\x86-gf2m.asm
	$(ASM) /Fo$@ $(TMP_D)\x86-gf2m.asm

$(OBJ_D)\bn_recp.obj: $(SRC_D)\crypto\bn\bn_recp.c
	$(CC) /Fo$(OBJ_D)\bn_recp.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_recp.c

$(OBJ_D)\bn_mont.obj: $(SRC_D)\crypto\bn\bn_mont.c
	$(CC) /Fo$(OBJ_D)\bn_mont.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_mont.c

$(OBJ_D)\bn_mpi.obj: $(SRC_D)\crypto\bn\bn_mpi.c
	$(CC) /Fo$(OBJ_D)\bn_mpi.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_mpi.c

$(OBJ_D)\bn_exp2.obj: $(SRC_D)\crypto\bn\bn_exp2.c
	$(CC) /Fo$(OBJ_D)\bn_exp2.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_exp2.c

$(OBJ_D)\bn_gf2m.obj: $(SRC_D)\crypto\bn\bn_gf2m.c
	$(CC) /Fo$(OBJ_D)\bn_gf2m.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_gf2m.c

$(OBJ_D)\bn_nist.obj: $(SRC_D)\crypto\bn\bn_nist.c
	$(CC) /Fo$(OBJ_D)\bn_nist.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_nist.c

$(OBJ_D)\bn_depr.obj: $(SRC_D)\crypto\bn\bn_depr.c
	$(CC) /Fo$(OBJ_D)\bn_depr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_depr.c

$(OBJ_D)\bn_const.obj: $(SRC_D)\crypto\bn\bn_const.c
	$(CC) /Fo$(OBJ_D)\bn_const.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_const.c

$(OBJ_D)\bn_x931p.obj: $(SRC_D)\crypto\bn\bn_x931p.c
	$(CC) /Fo$(OBJ_D)\bn_x931p.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bn\bn_x931p.c

$(OBJ_D)\rsa_eay.obj: $(SRC_D)\crypto\rsa\rsa_eay.c
	$(CC) /Fo$(OBJ_D)\rsa_eay.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_eay.c

$(OBJ_D)\rsa_gen.obj: $(SRC_D)\crypto\rsa\rsa_gen.c
	$(CC) /Fo$(OBJ_D)\rsa_gen.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_gen.c

$(OBJ_D)\rsa_lib.obj: $(SRC_D)\crypto\rsa\rsa_lib.c
	$(CC) /Fo$(OBJ_D)\rsa_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_lib.c

$(OBJ_D)\rsa_sign.obj: $(SRC_D)\crypto\rsa\rsa_sign.c
	$(CC) /Fo$(OBJ_D)\rsa_sign.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_sign.c

$(OBJ_D)\rsa_saos.obj: $(SRC_D)\crypto\rsa\rsa_saos.c
	$(CC) /Fo$(OBJ_D)\rsa_saos.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_saos.c

$(OBJ_D)\rsa_err.obj: $(SRC_D)\crypto\rsa\rsa_err.c
	$(CC) /Fo$(OBJ_D)\rsa_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_err.c

$(OBJ_D)\rsa_pk1.obj: $(SRC_D)\crypto\rsa\rsa_pk1.c
	$(CC) /Fo$(OBJ_D)\rsa_pk1.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_pk1.c

$(OBJ_D)\rsa_ssl.obj: $(SRC_D)\crypto\rsa\rsa_ssl.c
	$(CC) /Fo$(OBJ_D)\rsa_ssl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_ssl.c

$(OBJ_D)\rsa_none.obj: $(SRC_D)\crypto\rsa\rsa_none.c
	$(CC) /Fo$(OBJ_D)\rsa_none.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_none.c

$(OBJ_D)\rsa_oaep.obj: $(SRC_D)\crypto\rsa\rsa_oaep.c
	$(CC) /Fo$(OBJ_D)\rsa_oaep.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_oaep.c

$(OBJ_D)\rsa_chk.obj: $(SRC_D)\crypto\rsa\rsa_chk.c
	$(CC) /Fo$(OBJ_D)\rsa_chk.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_chk.c

$(OBJ_D)\rsa_null.obj: $(SRC_D)\crypto\rsa\rsa_null.c
	$(CC) /Fo$(OBJ_D)\rsa_null.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_null.c

$(OBJ_D)\rsa_pss.obj: $(SRC_D)\crypto\rsa\rsa_pss.c
	$(CC) /Fo$(OBJ_D)\rsa_pss.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_pss.c

$(OBJ_D)\rsa_x931.obj: $(SRC_D)\crypto\rsa\rsa_x931.c
	$(CC) /Fo$(OBJ_D)\rsa_x931.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_x931.c

$(OBJ_D)\rsa_asn1.obj: $(SRC_D)\crypto\rsa\rsa_asn1.c
	$(CC) /Fo$(OBJ_D)\rsa_asn1.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_asn1.c

$(OBJ_D)\rsa_depr.obj: $(SRC_D)\crypto\rsa\rsa_depr.c
	$(CC) /Fo$(OBJ_D)\rsa_depr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_depr.c

$(OBJ_D)\rsa_ameth.obj: $(SRC_D)\crypto\rsa\rsa_ameth.c
	$(CC) /Fo$(OBJ_D)\rsa_ameth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_ameth.c

$(OBJ_D)\rsa_prn.obj: $(SRC_D)\crypto\rsa\rsa_prn.c
	$(CC) /Fo$(OBJ_D)\rsa_prn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_prn.c

$(OBJ_D)\rsa_pmeth.obj: $(SRC_D)\crypto\rsa\rsa_pmeth.c
	$(CC) /Fo$(OBJ_D)\rsa_pmeth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_pmeth.c

$(OBJ_D)\rsa_crpt.obj: $(SRC_D)\crypto\rsa\rsa_crpt.c
	$(CC) /Fo$(OBJ_D)\rsa_crpt.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_crpt.c

$(OBJ_D)\dsa_gen.obj: $(SRC_D)\crypto\dsa\dsa_gen.c
	$(CC) /Fo$(OBJ_D)\dsa_gen.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dsa\dsa_gen.c

$(OBJ_D)\dsa_key.obj: $(SRC_D)\crypto\dsa\dsa_key.c
	$(CC) /Fo$(OBJ_D)\dsa_key.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dsa\dsa_key.c

$(OBJ_D)\dsa_lib.obj: $(SRC_D)\crypto\dsa\dsa_lib.c
	$(CC) /Fo$(OBJ_D)\dsa_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dsa\dsa_lib.c

$(OBJ_D)\dsa_asn1.obj: $(SRC_D)\crypto\dsa\dsa_asn1.c
	$(CC) /Fo$(OBJ_D)\dsa_asn1.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dsa\dsa_asn1.c

$(OBJ_D)\dsa_vrf.obj: $(SRC_D)\crypto\dsa\dsa_vrf.c
	$(CC) /Fo$(OBJ_D)\dsa_vrf.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dsa\dsa_vrf.c

$(OBJ_D)\dsa_sign.obj: $(SRC_D)\crypto\dsa\dsa_sign.c
	$(CC) /Fo$(OBJ_D)\dsa_sign.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dsa\dsa_sign.c

$(OBJ_D)\dsa_err.obj: $(SRC_D)\crypto\dsa\dsa_err.c
	$(CC) /Fo$(OBJ_D)\dsa_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dsa\dsa_err.c

$(OBJ_D)\dsa_ossl.obj: $(SRC_D)\crypto\dsa\dsa_ossl.c
	$(CC) /Fo$(OBJ_D)\dsa_ossl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dsa\dsa_ossl.c

$(OBJ_D)\dsa_depr.obj: $(SRC_D)\crypto\dsa\dsa_depr.c
	$(CC) /Fo$(OBJ_D)\dsa_depr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dsa\dsa_depr.c

$(OBJ_D)\dsa_ameth.obj: $(SRC_D)\crypto\dsa\dsa_ameth.c
	$(CC) /Fo$(OBJ_D)\dsa_ameth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dsa\dsa_ameth.c

$(OBJ_D)\dsa_pmeth.obj: $(SRC_D)\crypto\dsa\dsa_pmeth.c
	$(CC) /Fo$(OBJ_D)\dsa_pmeth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dsa\dsa_pmeth.c

$(OBJ_D)\dsa_prn.obj: $(SRC_D)\crypto\dsa\dsa_prn.c
	$(CC) /Fo$(OBJ_D)\dsa_prn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dsa\dsa_prn.c

$(OBJ_D)\dso_dl.obj: $(SRC_D)\crypto\dso\dso_dl.c
	$(CC) /Fo$(OBJ_D)\dso_dl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dso\dso_dl.c

$(OBJ_D)\dso_dlfcn.obj: $(SRC_D)\crypto\dso\dso_dlfcn.c
	$(CC) /Fo$(OBJ_D)\dso_dlfcn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dso\dso_dlfcn.c

$(OBJ_D)\dso_err.obj: $(SRC_D)\crypto\dso\dso_err.c
	$(CC) /Fo$(OBJ_D)\dso_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dso\dso_err.c

$(OBJ_D)\dso_lib.obj: $(SRC_D)\crypto\dso\dso_lib.c
	$(CC) /Fo$(OBJ_D)\dso_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dso\dso_lib.c

$(OBJ_D)\dso_null.obj: $(SRC_D)\crypto\dso\dso_null.c
	$(CC) /Fo$(OBJ_D)\dso_null.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dso\dso_null.c

$(OBJ_D)\dso_openssl.obj: $(SRC_D)\crypto\dso\dso_openssl.c
	$(CC) /Fo$(OBJ_D)\dso_openssl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dso\dso_openssl.c

$(OBJ_D)\dso_win32.obj: $(SRC_D)\crypto\dso\dso_win32.c
	$(CC) /Fo$(OBJ_D)\dso_win32.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dso\dso_win32.c

$(OBJ_D)\dso_vms.obj: $(SRC_D)\crypto\dso\dso_vms.c
	$(CC) /Fo$(OBJ_D)\dso_vms.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dso\dso_vms.c

$(OBJ_D)\dso_beos.obj: $(SRC_D)\crypto\dso\dso_beos.c
	$(CC) /Fo$(OBJ_D)\dso_beos.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dso\dso_beos.c

$(OBJ_D)\dh_asn1.obj: $(SRC_D)\crypto\dh\dh_asn1.c
	$(CC) /Fo$(OBJ_D)\dh_asn1.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dh\dh_asn1.c

$(OBJ_D)\dh_gen.obj: $(SRC_D)\crypto\dh\dh_gen.c
	$(CC) /Fo$(OBJ_D)\dh_gen.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dh\dh_gen.c

$(OBJ_D)\dh_key.obj: $(SRC_D)\crypto\dh\dh_key.c
	$(CC) /Fo$(OBJ_D)\dh_key.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dh\dh_key.c

$(OBJ_D)\dh_lib.obj: $(SRC_D)\crypto\dh\dh_lib.c
	$(CC) /Fo$(OBJ_D)\dh_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dh\dh_lib.c

$(OBJ_D)\dh_check.obj: $(SRC_D)\crypto\dh\dh_check.c
	$(CC) /Fo$(OBJ_D)\dh_check.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dh\dh_check.c

$(OBJ_D)\dh_err.obj: $(SRC_D)\crypto\dh\dh_err.c
	$(CC) /Fo$(OBJ_D)\dh_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dh\dh_err.c

$(OBJ_D)\dh_depr.obj: $(SRC_D)\crypto\dh\dh_depr.c
	$(CC) /Fo$(OBJ_D)\dh_depr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dh\dh_depr.c

$(OBJ_D)\dh_ameth.obj: $(SRC_D)\crypto\dh\dh_ameth.c
	$(CC) /Fo$(OBJ_D)\dh_ameth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dh\dh_ameth.c

$(OBJ_D)\dh_pmeth.obj: $(SRC_D)\crypto\dh\dh_pmeth.c
	$(CC) /Fo$(OBJ_D)\dh_pmeth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dh\dh_pmeth.c

$(OBJ_D)\dh_prn.obj: $(SRC_D)\crypto\dh\dh_prn.c
	$(CC) /Fo$(OBJ_D)\dh_prn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\dh\dh_prn.c

$(OBJ_D)\ec_lib.obj: $(SRC_D)\crypto\ec\ec_lib.c
	$(CC) /Fo$(OBJ_D)\ec_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec_lib.c

$(OBJ_D)\ecp_smpl.obj: $(SRC_D)\crypto\ec\ecp_smpl.c
	$(CC) /Fo$(OBJ_D)\ecp_smpl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ecp_smpl.c

$(OBJ_D)\ecp_mont.obj: $(SRC_D)\crypto\ec\ecp_mont.c
	$(CC) /Fo$(OBJ_D)\ecp_mont.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ecp_mont.c

$(OBJ_D)\ecp_nist.obj: $(SRC_D)\crypto\ec\ecp_nist.c
	$(CC) /Fo$(OBJ_D)\ecp_nist.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ecp_nist.c

$(OBJ_D)\ec_cvt.obj: $(SRC_D)\crypto\ec\ec_cvt.c
	$(CC) /Fo$(OBJ_D)\ec_cvt.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec_cvt.c

$(OBJ_D)\ec_mult.obj: $(SRC_D)\crypto\ec\ec_mult.c
	$(CC) /Fo$(OBJ_D)\ec_mult.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec_mult.c

$(OBJ_D)\ec_err.obj: $(SRC_D)\crypto\ec\ec_err.c
	$(CC) /Fo$(OBJ_D)\ec_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec_err.c

$(OBJ_D)\ec_curve.obj: $(SRC_D)\crypto\ec\ec_curve.c
	$(CC) /Fo$(OBJ_D)\ec_curve.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec_curve.c

$(OBJ_D)\ec_check.obj: $(SRC_D)\crypto\ec\ec_check.c
	$(CC) /Fo$(OBJ_D)\ec_check.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec_check.c

$(OBJ_D)\ec_print.obj: $(SRC_D)\crypto\ec\ec_print.c
	$(CC) /Fo$(OBJ_D)\ec_print.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec_print.c

$(OBJ_D)\ec_asn1.obj: $(SRC_D)\crypto\ec\ec_asn1.c
	$(CC) /Fo$(OBJ_D)\ec_asn1.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec_asn1.c

$(OBJ_D)\ec_key.obj: $(SRC_D)\crypto\ec\ec_key.c
	$(CC) /Fo$(OBJ_D)\ec_key.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec_key.c

$(OBJ_D)\ec2_smpl.obj: $(SRC_D)\crypto\ec\ec2_smpl.c
	$(CC) /Fo$(OBJ_D)\ec2_smpl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec2_smpl.c

$(OBJ_D)\ec2_mult.obj: $(SRC_D)\crypto\ec\ec2_mult.c
	$(CC) /Fo$(OBJ_D)\ec2_mult.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec2_mult.c

$(OBJ_D)\ec_ameth.obj: $(SRC_D)\crypto\ec\ec_ameth.c
	$(CC) /Fo$(OBJ_D)\ec_ameth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec_ameth.c

$(OBJ_D)\ec_pmeth.obj: $(SRC_D)\crypto\ec\ec_pmeth.c
	$(CC) /Fo$(OBJ_D)\ec_pmeth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec_pmeth.c

$(OBJ_D)\eck_prn.obj: $(SRC_D)\crypto\ec\eck_prn.c
	$(CC) /Fo$(OBJ_D)\eck_prn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\eck_prn.c

$(OBJ_D)\ecp_oct.obj: $(SRC_D)\crypto\ec\ecp_oct.c
	$(CC) /Fo$(OBJ_D)\ecp_oct.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ecp_oct.c

$(OBJ_D)\ec2_oct.obj: $(SRC_D)\crypto\ec\ec2_oct.c
	$(CC) /Fo$(OBJ_D)\ec2_oct.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec2_oct.c

$(OBJ_D)\ec_oct.obj: $(SRC_D)\crypto\ec\ec_oct.c
	$(CC) /Fo$(OBJ_D)\ec_oct.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ec\ec_oct.c

$(OBJ_D)\ech_lib.obj: $(SRC_D)\crypto\ecdh\ech_lib.c
	$(CC) /Fo$(OBJ_D)\ech_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ecdh\ech_lib.c

$(OBJ_D)\ech_ossl.obj: $(SRC_D)\crypto\ecdh\ech_ossl.c
	$(CC) /Fo$(OBJ_D)\ech_ossl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ecdh\ech_ossl.c

$(OBJ_D)\ech_key.obj: $(SRC_D)\crypto\ecdh\ech_key.c
	$(CC) /Fo$(OBJ_D)\ech_key.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ecdh\ech_key.c

$(OBJ_D)\ech_err.obj: $(SRC_D)\crypto\ecdh\ech_err.c
	$(CC) /Fo$(OBJ_D)\ech_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ecdh\ech_err.c

$(OBJ_D)\ecs_lib.obj: $(SRC_D)\crypto\ecdsa\ecs_lib.c
	$(CC) /Fo$(OBJ_D)\ecs_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ecdsa\ecs_lib.c

$(OBJ_D)\ecs_asn1.obj: $(SRC_D)\crypto\ecdsa\ecs_asn1.c
	$(CC) /Fo$(OBJ_D)\ecs_asn1.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ecdsa\ecs_asn1.c

$(OBJ_D)\ecs_ossl.obj: $(SRC_D)\crypto\ecdsa\ecs_ossl.c
	$(CC) /Fo$(OBJ_D)\ecs_ossl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ecdsa\ecs_ossl.c

$(OBJ_D)\ecs_sign.obj: $(SRC_D)\crypto\ecdsa\ecs_sign.c
	$(CC) /Fo$(OBJ_D)\ecs_sign.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ecdsa\ecs_sign.c

$(OBJ_D)\ecs_vrf.obj: $(SRC_D)\crypto\ecdsa\ecs_vrf.c
	$(CC) /Fo$(OBJ_D)\ecs_vrf.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ecdsa\ecs_vrf.c

$(OBJ_D)\ecs_err.obj: $(SRC_D)\crypto\ecdsa\ecs_err.c
	$(CC) /Fo$(OBJ_D)\ecs_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ecdsa\ecs_err.c

$(OBJ_D)\buffer.obj: $(SRC_D)\crypto\buffer\buffer.c
	$(CC) /Fo$(OBJ_D)\buffer.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\buffer\buffer.c

$(OBJ_D)\buf_str.obj: $(SRC_D)\crypto\buffer\buf_str.c
	$(CC) /Fo$(OBJ_D)\buf_str.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\buffer\buf_str.c

$(OBJ_D)\buf_err.obj: $(SRC_D)\crypto\buffer\buf_err.c
	$(CC) /Fo$(OBJ_D)\buf_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\buffer\buf_err.c

$(OBJ_D)\bio_lib.obj: $(SRC_D)\crypto\bio\bio_lib.c
	$(CC) /Fo$(OBJ_D)\bio_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bio_lib.c

$(OBJ_D)\bio_cb.obj: $(SRC_D)\crypto\bio\bio_cb.c
	$(CC) /Fo$(OBJ_D)\bio_cb.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bio_cb.c

$(OBJ_D)\bio_err.obj: $(SRC_D)\crypto\bio\bio_err.c
	$(CC) /Fo$(OBJ_D)\bio_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bio_err.c

$(OBJ_D)\bss_mem.obj: $(SRC_D)\crypto\bio\bss_mem.c
	$(CC) /Fo$(OBJ_D)\bss_mem.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bss_mem.c

$(OBJ_D)\bss_null.obj: $(SRC_D)\crypto\bio\bss_null.c
	$(CC) /Fo$(OBJ_D)\bss_null.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bss_null.c

$(OBJ_D)\bss_fd.obj: $(SRC_D)\crypto\bio\bss_fd.c
	$(CC) /Fo$(OBJ_D)\bss_fd.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bss_fd.c

$(OBJ_D)\bss_file.obj: $(SRC_D)\crypto\bio\bss_file.c
	$(CC) /Fo$(OBJ_D)\bss_file.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bss_file.c

$(OBJ_D)\bss_sock.obj: $(SRC_D)\crypto\bio\bss_sock.c
	$(CC) /Fo$(OBJ_D)\bss_sock.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bss_sock.c

$(OBJ_D)\bss_conn.obj: $(SRC_D)\crypto\bio\bss_conn.c
	$(CC) /Fo$(OBJ_D)\bss_conn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bss_conn.c

$(OBJ_D)\bf_null.obj: $(SRC_D)\crypto\bio\bf_null.c
	$(CC) /Fo$(OBJ_D)\bf_null.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bf_null.c

$(OBJ_D)\bf_buff.obj: $(SRC_D)\crypto\bio\bf_buff.c
	$(CC) /Fo$(OBJ_D)\bf_buff.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bf_buff.c

$(OBJ_D)\b_print.obj: $(SRC_D)\crypto\bio\b_print.c
	$(CC) /Fo$(OBJ_D)\b_print.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\b_print.c

$(OBJ_D)\b_dump.obj: $(SRC_D)\crypto\bio\b_dump.c
	$(CC) /Fo$(OBJ_D)\b_dump.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\b_dump.c

$(OBJ_D)\b_sock.obj: $(SRC_D)\crypto\bio\b_sock.c
	$(CC) /Fo$(OBJ_D)\b_sock.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\b_sock.c

$(OBJ_D)\bss_acpt.obj: $(SRC_D)\crypto\bio\bss_acpt.c
	$(CC) /Fo$(OBJ_D)\bss_acpt.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bss_acpt.c

$(OBJ_D)\bf_nbio.obj: $(SRC_D)\crypto\bio\bf_nbio.c
	$(CC) /Fo$(OBJ_D)\bf_nbio.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bf_nbio.c

$(OBJ_D)\bss_log.obj: $(SRC_D)\crypto\bio\bss_log.c
	$(CC) /Fo$(OBJ_D)\bss_log.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bss_log.c

$(OBJ_D)\bss_bio.obj: $(SRC_D)\crypto\bio\bss_bio.c
	$(CC) /Fo$(OBJ_D)\bss_bio.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bss_bio.c

$(OBJ_D)\bss_dgram.obj: $(SRC_D)\crypto\bio\bss_dgram.c
	$(CC) /Fo$(OBJ_D)\bss_dgram.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\bio\bss_dgram.c

$(OBJ_D)\stack.obj: $(SRC_D)\crypto\stack\stack.c
	$(CC) /Fo$(OBJ_D)\stack.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\stack\stack.c

$(OBJ_D)\lhash.obj: $(SRC_D)\crypto\lhash\lhash.c
	$(CC) /Fo$(OBJ_D)\lhash.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\lhash\lhash.c

$(OBJ_D)\lh_stats.obj: $(SRC_D)\crypto\lhash\lh_stats.c
	$(CC) /Fo$(OBJ_D)\lh_stats.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\lhash\lh_stats.c

$(OBJ_D)\md_rand.obj: $(SRC_D)\crypto\rand\md_rand.c
	$(CC) /Fo$(OBJ_D)\md_rand.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rand\md_rand.c

$(OBJ_D)\randfile.obj: $(SRC_D)\crypto\rand\randfile.c
	$(CC) /Fo$(OBJ_D)\randfile.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rand\randfile.c

$(OBJ_D)\rand_lib.obj: $(SRC_D)\crypto\rand\rand_lib.c
	$(CC) /Fo$(OBJ_D)\rand_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rand\rand_lib.c

$(OBJ_D)\rand_err.obj: $(SRC_D)\crypto\rand\rand_err.c
	$(CC) /Fo$(OBJ_D)\rand_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rand\rand_err.c

$(OBJ_D)\rand_egd.obj: $(SRC_D)\crypto\rand\rand_egd.c
	$(CC) /Fo$(OBJ_D)\rand_egd.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rand\rand_egd.c

$(OBJ_D)\rand_win.obj: $(SRC_D)\crypto\rand\rand_win.c
	$(CC) /Fo$(OBJ_D)\rand_win.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rand\rand_win.c

$(OBJ_D)\rand_unix.obj: $(SRC_D)\crypto\rand\rand_unix.c
	$(CC) /Fo$(OBJ_D)\rand_unix.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rand\rand_unix.c

$(OBJ_D)\rand_os2.obj: $(SRC_D)\crypto\rand\rand_os2.c
	$(CC) /Fo$(OBJ_D)\rand_os2.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rand\rand_os2.c

$(OBJ_D)\rand_nw.obj: $(SRC_D)\crypto\rand\rand_nw.c
	$(CC) /Fo$(OBJ_D)\rand_nw.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\rand\rand_nw.c

$(OBJ_D)\err.obj: $(SRC_D)\crypto\err\err.c
	$(CC) /Fo$(OBJ_D)\err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\err\err.c

$(OBJ_D)\err_all.obj: $(SRC_D)\crypto\err\err_all.c
	$(CC) /Fo$(OBJ_D)\err_all.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\err\err_all.c

$(OBJ_D)\err_prn.obj: $(SRC_D)\crypto\err\err_prn.c
	$(CC) /Fo$(OBJ_D)\err_prn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\err\err_prn.c

$(OBJ_D)\o_names.obj: $(SRC_D)\crypto\objects\o_names.c
	$(CC) /Fo$(OBJ_D)\o_names.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\objects\o_names.c

$(OBJ_D)\obj_dat.obj: $(SRC_D)\crypto\objects\obj_dat.c
	$(CC) /Fo$(OBJ_D)\obj_dat.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\objects\obj_dat.c

$(OBJ_D)\obj_lib.obj: $(SRC_D)\crypto\objects\obj_lib.c
	$(CC) /Fo$(OBJ_D)\obj_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\objects\obj_lib.c

$(OBJ_D)\obj_err.obj: $(SRC_D)\crypto\objects\obj_err.c
	$(CC) /Fo$(OBJ_D)\obj_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\objects\obj_err.c

$(OBJ_D)\obj_xref.obj: $(SRC_D)\crypto\objects\obj_xref.c
	$(CC) /Fo$(OBJ_D)\obj_xref.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\objects\obj_xref.c

$(OBJ_D)\encode.obj: $(SRC_D)\crypto\evp\encode.c
	$(CC) /Fo$(OBJ_D)\encode.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\encode.c

$(OBJ_D)\digest.obj: $(SRC_D)\crypto\evp\digest.c
	$(CC) /Fo$(OBJ_D)\digest.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\digest.c

$(OBJ_D)\evp_enc.obj: $(SRC_D)\crypto\evp\evp_enc.c
	$(CC) /Fo$(OBJ_D)\evp_enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\evp_enc.c

$(OBJ_D)\evp_key.obj: $(SRC_D)\crypto\evp\evp_key.c
	$(CC) /Fo$(OBJ_D)\evp_key.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\evp_key.c

$(OBJ_D)\evp_acnf.obj: $(SRC_D)\crypto\evp\evp_acnf.c
	$(CC) /Fo$(OBJ_D)\evp_acnf.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\evp_acnf.c

$(OBJ_D)\evp_cnf.obj: $(SRC_D)\crypto\evp\evp_cnf.c
	$(CC) /Fo$(OBJ_D)\evp_cnf.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\evp_cnf.c

$(OBJ_D)\e_des.obj: $(SRC_D)\crypto\evp\e_des.c
	$(CC) /Fo$(OBJ_D)\e_des.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_des.c

$(OBJ_D)\e_bf.obj: $(SRC_D)\crypto\evp\e_bf.c
	$(CC) /Fo$(OBJ_D)\e_bf.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_bf.c

$(OBJ_D)\e_idea.obj: $(SRC_D)\crypto\evp\e_idea.c
	$(CC) /Fo$(OBJ_D)\e_idea.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_idea.c

$(OBJ_D)\e_des3.obj: $(SRC_D)\crypto\evp\e_des3.c
	$(CC) /Fo$(OBJ_D)\e_des3.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_des3.c

$(OBJ_D)\e_rc4.obj: $(SRC_D)\crypto\evp\e_rc4.c
	$(CC) /Fo$(OBJ_D)\e_rc4.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_rc4.c

$(OBJ_D)\e_aes.obj: $(SRC_D)\crypto\evp\e_aes.c
	$(CC) /Fo$(OBJ_D)\e_aes.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_aes.c

$(OBJ_D)\names.obj: $(SRC_D)\crypto\evp\names.c
	$(CC) /Fo$(OBJ_D)\names.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\names.c

$(OBJ_D)\e_xcbc_d.obj: $(SRC_D)\crypto\evp\e_xcbc_d.c
	$(CC) /Fo$(OBJ_D)\e_xcbc_d.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_xcbc_d.c

$(OBJ_D)\e_rc2.obj: $(SRC_D)\crypto\evp\e_rc2.c
	$(CC) /Fo$(OBJ_D)\e_rc2.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_rc2.c

$(OBJ_D)\e_cast.obj: $(SRC_D)\crypto\evp\e_cast.c
	$(CC) /Fo$(OBJ_D)\e_cast.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_cast.c

$(OBJ_D)\e_rc5.obj: $(SRC_D)\crypto\evp\e_rc5.c
	$(CC) /Fo$(OBJ_D)\e_rc5.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_rc5.c

$(OBJ_D)\m_null.obj: $(SRC_D)\crypto\evp\m_null.c
	$(CC) /Fo$(OBJ_D)\m_null.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\m_null.c

$(OBJ_D)\m_md4.obj: $(SRC_D)\crypto\evp\m_md4.c
	$(CC) /Fo$(OBJ_D)\m_md4.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\m_md4.c

$(OBJ_D)\m_md5.obj: $(SRC_D)\crypto\evp\m_md5.c
	$(CC) /Fo$(OBJ_D)\m_md5.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\m_md5.c

$(OBJ_D)\m_sha.obj: $(SRC_D)\crypto\evp\m_sha.c
	$(CC) /Fo$(OBJ_D)\m_sha.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\m_sha.c

$(OBJ_D)\m_sha1.obj: $(SRC_D)\crypto\evp\m_sha1.c
	$(CC) /Fo$(OBJ_D)\m_sha1.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\m_sha1.c

$(OBJ_D)\m_wp.obj: $(SRC_D)\crypto\evp\m_wp.c
	$(CC) /Fo$(OBJ_D)\m_wp.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\m_wp.c

$(OBJ_D)\m_dss.obj: $(SRC_D)\crypto\evp\m_dss.c
	$(CC) /Fo$(OBJ_D)\m_dss.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\m_dss.c

$(OBJ_D)\m_dss1.obj: $(SRC_D)\crypto\evp\m_dss1.c
	$(CC) /Fo$(OBJ_D)\m_dss1.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\m_dss1.c

$(OBJ_D)\m_md2.obj: $(SRC_D)\crypto\evp\m_md2.c
	$(CC) /Fo$(OBJ_D)\m_md2.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\m_md2.c

$(OBJ_D)\m_ripemd.obj: $(SRC_D)\crypto\evp\m_ripemd.c
	$(CC) /Fo$(OBJ_D)\m_ripemd.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\m_ripemd.c

$(OBJ_D)\m_ecdsa.obj: $(SRC_D)\crypto\evp\m_ecdsa.c
	$(CC) /Fo$(OBJ_D)\m_ecdsa.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\m_ecdsa.c

$(OBJ_D)\p_open.obj: $(SRC_D)\crypto\evp\p_open.c
	$(CC) /Fo$(OBJ_D)\p_open.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\p_open.c

$(OBJ_D)\p_seal.obj: $(SRC_D)\crypto\evp\p_seal.c
	$(CC) /Fo$(OBJ_D)\p_seal.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\p_seal.c

$(OBJ_D)\p_sign.obj: $(SRC_D)\crypto\evp\p_sign.c
	$(CC) /Fo$(OBJ_D)\p_sign.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\p_sign.c

$(OBJ_D)\p_verify.obj: $(SRC_D)\crypto\evp\p_verify.c
	$(CC) /Fo$(OBJ_D)\p_verify.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\p_verify.c

$(OBJ_D)\p_lib.obj: $(SRC_D)\crypto\evp\p_lib.c
	$(CC) /Fo$(OBJ_D)\p_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\p_lib.c

$(OBJ_D)\p_enc.obj: $(SRC_D)\crypto\evp\p_enc.c
	$(CC) /Fo$(OBJ_D)\p_enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\p_enc.c

$(OBJ_D)\p_dec.obj: $(SRC_D)\crypto\evp\p_dec.c
	$(CC) /Fo$(OBJ_D)\p_dec.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\p_dec.c

$(OBJ_D)\bio_md.obj: $(SRC_D)\crypto\evp\bio_md.c
	$(CC) /Fo$(OBJ_D)\bio_md.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\bio_md.c

$(OBJ_D)\bio_b64.obj: $(SRC_D)\crypto\evp\bio_b64.c
	$(CC) /Fo$(OBJ_D)\bio_b64.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\bio_b64.c

$(OBJ_D)\bio_enc.obj: $(SRC_D)\crypto\evp\bio_enc.c
	$(CC) /Fo$(OBJ_D)\bio_enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\bio_enc.c

$(OBJ_D)\evp_err.obj: $(SRC_D)\crypto\evp\evp_err.c
	$(CC) /Fo$(OBJ_D)\evp_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\evp_err.c

$(OBJ_D)\e_null.obj: $(SRC_D)\crypto\evp\e_null.c
	$(CC) /Fo$(OBJ_D)\e_null.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_null.c

$(OBJ_D)\c_all.obj: $(SRC_D)\crypto\evp\c_all.c
	$(CC) /Fo$(OBJ_D)\c_all.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\c_all.c

$(OBJ_D)\c_allc.obj: $(SRC_D)\crypto\evp\c_allc.c
	$(CC) /Fo$(OBJ_D)\c_allc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\c_allc.c

$(OBJ_D)\c_alld.obj: $(SRC_D)\crypto\evp\c_alld.c
	$(CC) /Fo$(OBJ_D)\c_alld.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\c_alld.c

$(OBJ_D)\evp_lib.obj: $(SRC_D)\crypto\evp\evp_lib.c
	$(CC) /Fo$(OBJ_D)\evp_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\evp_lib.c

$(OBJ_D)\bio_ok.obj: $(SRC_D)\crypto\evp\bio_ok.c
	$(CC) /Fo$(OBJ_D)\bio_ok.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\bio_ok.c

$(OBJ_D)\evp_pkey.obj: $(SRC_D)\crypto\evp\evp_pkey.c
	$(CC) /Fo$(OBJ_D)\evp_pkey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\evp_pkey.c

$(OBJ_D)\evp_pbe.obj: $(SRC_D)\crypto\evp\evp_pbe.c
	$(CC) /Fo$(OBJ_D)\evp_pbe.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\evp_pbe.c

$(OBJ_D)\p5_crpt.obj: $(SRC_D)\crypto\evp\p5_crpt.c
	$(CC) /Fo$(OBJ_D)\p5_crpt.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\p5_crpt.c

$(OBJ_D)\p5_crpt2.obj: $(SRC_D)\crypto\evp\p5_crpt2.c
	$(CC) /Fo$(OBJ_D)\p5_crpt2.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\p5_crpt2.c

$(OBJ_D)\e_old.obj: $(SRC_D)\crypto\evp\e_old.c
	$(CC) /Fo$(OBJ_D)\e_old.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_old.c

$(OBJ_D)\pmeth_lib.obj: $(SRC_D)\crypto\evp\pmeth_lib.c
	$(CC) /Fo$(OBJ_D)\pmeth_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\pmeth_lib.c

$(OBJ_D)\pmeth_fn.obj: $(SRC_D)\crypto\evp\pmeth_fn.c
	$(CC) /Fo$(OBJ_D)\pmeth_fn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\pmeth_fn.c

$(OBJ_D)\pmeth_gn.obj: $(SRC_D)\crypto\evp\pmeth_gn.c
	$(CC) /Fo$(OBJ_D)\pmeth_gn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\pmeth_gn.c

$(OBJ_D)\m_sigver.obj: $(SRC_D)\crypto\evp\m_sigver.c
	$(CC) /Fo$(OBJ_D)\m_sigver.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\m_sigver.c

$(OBJ_D)\evp_fips.obj: $(SRC_D)\crypto\evp\evp_fips.c
	$(CC) /Fo$(OBJ_D)\evp_fips.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\evp_fips.c

$(OBJ_D)\e_aes_cbc_hmac_sha1.obj: $(SRC_D)\crypto\evp\e_aes_cbc_hmac_sha1.c
	$(CC) /Fo$(OBJ_D)\e_aes_cbc_hmac_sha1.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_aes_cbc_hmac_sha1.c

$(OBJ_D)\e_rc4_hmac_md5.obj: $(SRC_D)\crypto\evp\e_rc4_hmac_md5.c
	$(CC) /Fo$(OBJ_D)\e_rc4_hmac_md5.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\evp\e_rc4_hmac_md5.c

$(OBJ_D)\a_object.obj: $(SRC_D)\crypto\asn1\a_object.c
	$(CC) /Fo$(OBJ_D)\a_object.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_object.c

$(OBJ_D)\a_bitstr.obj: $(SRC_D)\crypto\asn1\a_bitstr.c
	$(CC) /Fo$(OBJ_D)\a_bitstr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_bitstr.c

$(OBJ_D)\a_utctm.obj: $(SRC_D)\crypto\asn1\a_utctm.c
	$(CC) /Fo$(OBJ_D)\a_utctm.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_utctm.c

$(OBJ_D)\a_gentm.obj: $(SRC_D)\crypto\asn1\a_gentm.c
	$(CC) /Fo$(OBJ_D)\a_gentm.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_gentm.c

$(OBJ_D)\a_time.obj: $(SRC_D)\crypto\asn1\a_time.c
	$(CC) /Fo$(OBJ_D)\a_time.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_time.c

$(OBJ_D)\a_int.obj: $(SRC_D)\crypto\asn1\a_int.c
	$(CC) /Fo$(OBJ_D)\a_int.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_int.c

$(OBJ_D)\a_octet.obj: $(SRC_D)\crypto\asn1\a_octet.c
	$(CC) /Fo$(OBJ_D)\a_octet.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_octet.c

$(OBJ_D)\a_print.obj: $(SRC_D)\crypto\asn1\a_print.c
	$(CC) /Fo$(OBJ_D)\a_print.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_print.c

$(OBJ_D)\a_type.obj: $(SRC_D)\crypto\asn1\a_type.c
	$(CC) /Fo$(OBJ_D)\a_type.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_type.c

$(OBJ_D)\a_set.obj: $(SRC_D)\crypto\asn1\a_set.c
	$(CC) /Fo$(OBJ_D)\a_set.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_set.c

$(OBJ_D)\a_dup.obj: $(SRC_D)\crypto\asn1\a_dup.c
	$(CC) /Fo$(OBJ_D)\a_dup.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_dup.c

$(OBJ_D)\a_d2i_fp.obj: $(SRC_D)\crypto\asn1\a_d2i_fp.c
	$(CC) /Fo$(OBJ_D)\a_d2i_fp.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_d2i_fp.c

$(OBJ_D)\a_i2d_fp.obj: $(SRC_D)\crypto\asn1\a_i2d_fp.c
	$(CC) /Fo$(OBJ_D)\a_i2d_fp.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_i2d_fp.c

$(OBJ_D)\a_enum.obj: $(SRC_D)\crypto\asn1\a_enum.c
	$(CC) /Fo$(OBJ_D)\a_enum.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_enum.c

$(OBJ_D)\a_utf8.obj: $(SRC_D)\crypto\asn1\a_utf8.c
	$(CC) /Fo$(OBJ_D)\a_utf8.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_utf8.c

$(OBJ_D)\a_sign.obj: $(SRC_D)\crypto\asn1\a_sign.c
	$(CC) /Fo$(OBJ_D)\a_sign.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_sign.c

$(OBJ_D)\a_digest.obj: $(SRC_D)\crypto\asn1\a_digest.c
	$(CC) /Fo$(OBJ_D)\a_digest.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_digest.c

$(OBJ_D)\a_verify.obj: $(SRC_D)\crypto\asn1\a_verify.c
	$(CC) /Fo$(OBJ_D)\a_verify.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_verify.c

$(OBJ_D)\a_mbstr.obj: $(SRC_D)\crypto\asn1\a_mbstr.c
	$(CC) /Fo$(OBJ_D)\a_mbstr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_mbstr.c

$(OBJ_D)\a_strex.obj: $(SRC_D)\crypto\asn1\a_strex.c
	$(CC) /Fo$(OBJ_D)\a_strex.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_strex.c

$(OBJ_D)\x_algor.obj: $(SRC_D)\crypto\asn1\x_algor.c
	$(CC) /Fo$(OBJ_D)\x_algor.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_algor.c

$(OBJ_D)\x_val.obj: $(SRC_D)\crypto\asn1\x_val.c
	$(CC) /Fo$(OBJ_D)\x_val.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_val.c

$(OBJ_D)\x_pubkey.obj: $(SRC_D)\crypto\asn1\x_pubkey.c
	$(CC) /Fo$(OBJ_D)\x_pubkey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_pubkey.c

$(OBJ_D)\x_sig.obj: $(SRC_D)\crypto\asn1\x_sig.c
	$(CC) /Fo$(OBJ_D)\x_sig.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_sig.c

$(OBJ_D)\x_req.obj: $(SRC_D)\crypto\asn1\x_req.c
	$(CC) /Fo$(OBJ_D)\x_req.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_req.c

$(OBJ_D)\x_attrib.obj: $(SRC_D)\crypto\asn1\x_attrib.c
	$(CC) /Fo$(OBJ_D)\x_attrib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_attrib.c

$(OBJ_D)\x_bignum.obj: $(SRC_D)\crypto\asn1\x_bignum.c
	$(CC) /Fo$(OBJ_D)\x_bignum.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_bignum.c

$(OBJ_D)\x_long.obj: $(SRC_D)\crypto\asn1\x_long.c
	$(CC) /Fo$(OBJ_D)\x_long.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_long.c

$(OBJ_D)\x_name.obj: $(SRC_D)\crypto\asn1\x_name.c
	$(CC) /Fo$(OBJ_D)\x_name.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_name.c

$(OBJ_D)\x_x509.obj: $(SRC_D)\crypto\asn1\x_x509.c
	$(CC) /Fo$(OBJ_D)\x_x509.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_x509.c

$(OBJ_D)\x_x509a.obj: $(SRC_D)\crypto\asn1\x_x509a.c
	$(CC) /Fo$(OBJ_D)\x_x509a.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_x509a.c

$(OBJ_D)\x_crl.obj: $(SRC_D)\crypto\asn1\x_crl.c
	$(CC) /Fo$(OBJ_D)\x_crl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_crl.c

$(OBJ_D)\x_info.obj: $(SRC_D)\crypto\asn1\x_info.c
	$(CC) /Fo$(OBJ_D)\x_info.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_info.c

$(OBJ_D)\x_spki.obj: $(SRC_D)\crypto\asn1\x_spki.c
	$(CC) /Fo$(OBJ_D)\x_spki.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_spki.c

$(OBJ_D)\nsseq.obj: $(SRC_D)\crypto\asn1\nsseq.c
	$(CC) /Fo$(OBJ_D)\nsseq.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\nsseq.c

$(OBJ_D)\x_nx509.obj: $(SRC_D)\crypto\asn1\x_nx509.c
	$(CC) /Fo$(OBJ_D)\x_nx509.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_nx509.c

$(OBJ_D)\d2i_pu.obj: $(SRC_D)\crypto\asn1\d2i_pu.c
	$(CC) /Fo$(OBJ_D)\d2i_pu.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\d2i_pu.c

$(OBJ_D)\d2i_pr.obj: $(SRC_D)\crypto\asn1\d2i_pr.c
	$(CC) /Fo$(OBJ_D)\d2i_pr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\d2i_pr.c

$(OBJ_D)\i2d_pu.obj: $(SRC_D)\crypto\asn1\i2d_pu.c
	$(CC) /Fo$(OBJ_D)\i2d_pu.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\i2d_pu.c

$(OBJ_D)\i2d_pr.obj: $(SRC_D)\crypto\asn1\i2d_pr.c
	$(CC) /Fo$(OBJ_D)\i2d_pr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\i2d_pr.c

$(OBJ_D)\t_req.obj: $(SRC_D)\crypto\asn1\t_req.c
	$(CC) /Fo$(OBJ_D)\t_req.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\t_req.c

$(OBJ_D)\t_x509.obj: $(SRC_D)\crypto\asn1\t_x509.c
	$(CC) /Fo$(OBJ_D)\t_x509.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\t_x509.c

$(OBJ_D)\t_x509a.obj: $(SRC_D)\crypto\asn1\t_x509a.c
	$(CC) /Fo$(OBJ_D)\t_x509a.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\t_x509a.c

$(OBJ_D)\t_crl.obj: $(SRC_D)\crypto\asn1\t_crl.c
	$(CC) /Fo$(OBJ_D)\t_crl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\t_crl.c

$(OBJ_D)\t_pkey.obj: $(SRC_D)\crypto\asn1\t_pkey.c
	$(CC) /Fo$(OBJ_D)\t_pkey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\t_pkey.c

$(OBJ_D)\t_spki.obj: $(SRC_D)\crypto\asn1\t_spki.c
	$(CC) /Fo$(OBJ_D)\t_spki.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\t_spki.c

$(OBJ_D)\t_bitst.obj: $(SRC_D)\crypto\asn1\t_bitst.c
	$(CC) /Fo$(OBJ_D)\t_bitst.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\t_bitst.c

$(OBJ_D)\tasn_new.obj: $(SRC_D)\crypto\asn1\tasn_new.c
	$(CC) /Fo$(OBJ_D)\tasn_new.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\tasn_new.c

$(OBJ_D)\tasn_fre.obj: $(SRC_D)\crypto\asn1\tasn_fre.c
	$(CC) /Fo$(OBJ_D)\tasn_fre.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\tasn_fre.c

$(OBJ_D)\tasn_enc.obj: $(SRC_D)\crypto\asn1\tasn_enc.c
	$(CC) /Fo$(OBJ_D)\tasn_enc.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\tasn_enc.c

$(OBJ_D)\tasn_dec.obj: $(SRC_D)\crypto\asn1\tasn_dec.c
	$(CC) /Fo$(OBJ_D)\tasn_dec.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\tasn_dec.c

$(OBJ_D)\tasn_utl.obj: $(SRC_D)\crypto\asn1\tasn_utl.c
	$(CC) /Fo$(OBJ_D)\tasn_utl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\tasn_utl.c

$(OBJ_D)\tasn_typ.obj: $(SRC_D)\crypto\asn1\tasn_typ.c
	$(CC) /Fo$(OBJ_D)\tasn_typ.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\tasn_typ.c

$(OBJ_D)\tasn_prn.obj: $(SRC_D)\crypto\asn1\tasn_prn.c
	$(CC) /Fo$(OBJ_D)\tasn_prn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\tasn_prn.c

$(OBJ_D)\ameth_lib.obj: $(SRC_D)\crypto\asn1\ameth_lib.c
	$(CC) /Fo$(OBJ_D)\ameth_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\ameth_lib.c

$(OBJ_D)\f_int.obj: $(SRC_D)\crypto\asn1\f_int.c
	$(CC) /Fo$(OBJ_D)\f_int.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\f_int.c

$(OBJ_D)\f_string.obj: $(SRC_D)\crypto\asn1\f_string.c
	$(CC) /Fo$(OBJ_D)\f_string.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\f_string.c

$(OBJ_D)\n_pkey.obj: $(SRC_D)\crypto\asn1\n_pkey.c
	$(CC) /Fo$(OBJ_D)\n_pkey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\n_pkey.c

$(OBJ_D)\f_enum.obj: $(SRC_D)\crypto\asn1\f_enum.c
	$(CC) /Fo$(OBJ_D)\f_enum.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\f_enum.c

$(OBJ_D)\x_pkey.obj: $(SRC_D)\crypto\asn1\x_pkey.c
	$(CC) /Fo$(OBJ_D)\x_pkey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_pkey.c

$(OBJ_D)\a_bool.obj: $(SRC_D)\crypto\asn1\a_bool.c
	$(CC) /Fo$(OBJ_D)\a_bool.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_bool.c

$(OBJ_D)\x_exten.obj: $(SRC_D)\crypto\asn1\x_exten.c
	$(CC) /Fo$(OBJ_D)\x_exten.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\x_exten.c

$(OBJ_D)\bio_asn1.obj: $(SRC_D)\crypto\asn1\bio_asn1.c
	$(CC) /Fo$(OBJ_D)\bio_asn1.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\bio_asn1.c

$(OBJ_D)\bio_ndef.obj: $(SRC_D)\crypto\asn1\bio_ndef.c
	$(CC) /Fo$(OBJ_D)\bio_ndef.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\bio_ndef.c

$(OBJ_D)\asn_mime.obj: $(SRC_D)\crypto\asn1\asn_mime.c
	$(CC) /Fo$(OBJ_D)\asn_mime.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\asn_mime.c

$(OBJ_D)\asn1_gen.obj: $(SRC_D)\crypto\asn1\asn1_gen.c
	$(CC) /Fo$(OBJ_D)\asn1_gen.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\asn1_gen.c

$(OBJ_D)\asn1_par.obj: $(SRC_D)\crypto\asn1\asn1_par.c
	$(CC) /Fo$(OBJ_D)\asn1_par.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\asn1_par.c

$(OBJ_D)\asn1_lib.obj: $(SRC_D)\crypto\asn1\asn1_lib.c
	$(CC) /Fo$(OBJ_D)\asn1_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\asn1_lib.c

$(OBJ_D)\asn1_err.obj: $(SRC_D)\crypto\asn1\asn1_err.c
	$(CC) /Fo$(OBJ_D)\asn1_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\asn1_err.c

$(OBJ_D)\a_bytes.obj: $(SRC_D)\crypto\asn1\a_bytes.c
	$(CC) /Fo$(OBJ_D)\a_bytes.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_bytes.c

$(OBJ_D)\a_strnid.obj: $(SRC_D)\crypto\asn1\a_strnid.c
	$(CC) /Fo$(OBJ_D)\a_strnid.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\a_strnid.c

$(OBJ_D)\evp_asn1.obj: $(SRC_D)\crypto\asn1\evp_asn1.c
	$(CC) /Fo$(OBJ_D)\evp_asn1.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\evp_asn1.c

$(OBJ_D)\asn_pack.obj: $(SRC_D)\crypto\asn1\asn_pack.c
	$(CC) /Fo$(OBJ_D)\asn_pack.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\asn_pack.c

$(OBJ_D)\p5_pbe.obj: $(SRC_D)\crypto\asn1\p5_pbe.c
	$(CC) /Fo$(OBJ_D)\p5_pbe.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\p5_pbe.c

$(OBJ_D)\p5_pbev2.obj: $(SRC_D)\crypto\asn1\p5_pbev2.c
	$(CC) /Fo$(OBJ_D)\p5_pbev2.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\p5_pbev2.c

$(OBJ_D)\p8_pkey.obj: $(SRC_D)\crypto\asn1\p8_pkey.c
	$(CC) /Fo$(OBJ_D)\p8_pkey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\p8_pkey.c

$(OBJ_D)\asn_moid.obj: $(SRC_D)\crypto\asn1\asn_moid.c
	$(CC) /Fo$(OBJ_D)\asn_moid.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\asn1\asn_moid.c

$(OBJ_D)\pem_sign.obj: $(SRC_D)\crypto\pem\pem_sign.c
	$(CC) /Fo$(OBJ_D)\pem_sign.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pem\pem_sign.c

$(OBJ_D)\pem_seal.obj: $(SRC_D)\crypto\pem\pem_seal.c
	$(CC) /Fo$(OBJ_D)\pem_seal.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pem\pem_seal.c

$(OBJ_D)\pem_info.obj: $(SRC_D)\crypto\pem\pem_info.c
	$(CC) /Fo$(OBJ_D)\pem_info.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pem\pem_info.c

$(OBJ_D)\pem_lib.obj: $(SRC_D)\crypto\pem\pem_lib.c
	$(CC) /Fo$(OBJ_D)\pem_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pem\pem_lib.c

$(OBJ_D)\pem_all.obj: $(SRC_D)\crypto\pem\pem_all.c
	$(CC) /Fo$(OBJ_D)\pem_all.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pem\pem_all.c

$(OBJ_D)\pem_err.obj: $(SRC_D)\crypto\pem\pem_err.c
	$(CC) /Fo$(OBJ_D)\pem_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pem\pem_err.c

$(OBJ_D)\pem_x509.obj: $(SRC_D)\crypto\pem\pem_x509.c
	$(CC) /Fo$(OBJ_D)\pem_x509.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pem\pem_x509.c

$(OBJ_D)\pem_xaux.obj: $(SRC_D)\crypto\pem\pem_xaux.c
	$(CC) /Fo$(OBJ_D)\pem_xaux.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pem\pem_xaux.c

$(OBJ_D)\pem_oth.obj: $(SRC_D)\crypto\pem\pem_oth.c
	$(CC) /Fo$(OBJ_D)\pem_oth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pem\pem_oth.c

$(OBJ_D)\pem_pk8.obj: $(SRC_D)\crypto\pem\pem_pk8.c
	$(CC) /Fo$(OBJ_D)\pem_pk8.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pem\pem_pk8.c

$(OBJ_D)\pem_pkey.obj: $(SRC_D)\crypto\pem\pem_pkey.c
	$(CC) /Fo$(OBJ_D)\pem_pkey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pem\pem_pkey.c

$(OBJ_D)\pvkfmt.obj: $(SRC_D)\crypto\pem\pvkfmt.c
	$(CC) /Fo$(OBJ_D)\pvkfmt.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pem\pvkfmt.c

$(OBJ_D)\x509_def.obj: $(SRC_D)\crypto\x509\x509_def.c
	$(CC) /Fo$(OBJ_D)\x509_def.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_def.c

$(OBJ_D)\x509_d2.obj: $(SRC_D)\crypto\x509\x509_d2.c
	$(CC) /Fo$(OBJ_D)\x509_d2.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_d2.c

$(OBJ_D)\x509_r2x.obj: $(SRC_D)\crypto\x509\x509_r2x.c
	$(CC) /Fo$(OBJ_D)\x509_r2x.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_r2x.c

$(OBJ_D)\x509_cmp.obj: $(SRC_D)\crypto\x509\x509_cmp.c
	$(CC) /Fo$(OBJ_D)\x509_cmp.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_cmp.c

$(OBJ_D)\x509_obj.obj: $(SRC_D)\crypto\x509\x509_obj.c
	$(CC) /Fo$(OBJ_D)\x509_obj.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_obj.c

$(OBJ_D)\x509_req.obj: $(SRC_D)\crypto\x509\x509_req.c
	$(CC) /Fo$(OBJ_D)\x509_req.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_req.c

$(OBJ_D)\x509spki.obj: $(SRC_D)\crypto\x509\x509spki.c
	$(CC) /Fo$(OBJ_D)\x509spki.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509spki.c

$(OBJ_D)\x509_vfy.obj: $(SRC_D)\crypto\x509\x509_vfy.c
	$(CC) /Fo$(OBJ_D)\x509_vfy.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_vfy.c

$(OBJ_D)\x509_set.obj: $(SRC_D)\crypto\x509\x509_set.c
	$(CC) /Fo$(OBJ_D)\x509_set.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_set.c

$(OBJ_D)\x509cset.obj: $(SRC_D)\crypto\x509\x509cset.c
	$(CC) /Fo$(OBJ_D)\x509cset.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509cset.c

$(OBJ_D)\x509rset.obj: $(SRC_D)\crypto\x509\x509rset.c
	$(CC) /Fo$(OBJ_D)\x509rset.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509rset.c

$(OBJ_D)\x509_err.obj: $(SRC_D)\crypto\x509\x509_err.c
	$(CC) /Fo$(OBJ_D)\x509_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_err.c

$(OBJ_D)\x509name.obj: $(SRC_D)\crypto\x509\x509name.c
	$(CC) /Fo$(OBJ_D)\x509name.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509name.c

$(OBJ_D)\x509_v3.obj: $(SRC_D)\crypto\x509\x509_v3.c
	$(CC) /Fo$(OBJ_D)\x509_v3.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_v3.c

$(OBJ_D)\x509_ext.obj: $(SRC_D)\crypto\x509\x509_ext.c
	$(CC) /Fo$(OBJ_D)\x509_ext.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_ext.c

$(OBJ_D)\x509_att.obj: $(SRC_D)\crypto\x509\x509_att.c
	$(CC) /Fo$(OBJ_D)\x509_att.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_att.c

$(OBJ_D)\x509type.obj: $(SRC_D)\crypto\x509\x509type.c
	$(CC) /Fo$(OBJ_D)\x509type.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509type.c

$(OBJ_D)\x509_lu.obj: $(SRC_D)\crypto\x509\x509_lu.c
	$(CC) /Fo$(OBJ_D)\x509_lu.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_lu.c

$(OBJ_D)\x_all.obj: $(SRC_D)\crypto\x509\x_all.c
	$(CC) /Fo$(OBJ_D)\x_all.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x_all.c

$(OBJ_D)\x509_txt.obj: $(SRC_D)\crypto\x509\x509_txt.c
	$(CC) /Fo$(OBJ_D)\x509_txt.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_txt.c

$(OBJ_D)\x509_trs.obj: $(SRC_D)\crypto\x509\x509_trs.c
	$(CC) /Fo$(OBJ_D)\x509_trs.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_trs.c

$(OBJ_D)\by_file.obj: $(SRC_D)\crypto\x509\by_file.c
	$(CC) /Fo$(OBJ_D)\by_file.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\by_file.c

$(OBJ_D)\by_dir.obj: $(SRC_D)\crypto\x509\by_dir.c
	$(CC) /Fo$(OBJ_D)\by_dir.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\by_dir.c

$(OBJ_D)\x509_vpm.obj: $(SRC_D)\crypto\x509\x509_vpm.c
	$(CC) /Fo$(OBJ_D)\x509_vpm.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509\x509_vpm.c

$(OBJ_D)\v3_bcons.obj: $(SRC_D)\crypto\x509v3\v3_bcons.c
	$(CC) /Fo$(OBJ_D)\v3_bcons.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_bcons.c

$(OBJ_D)\v3_bitst.obj: $(SRC_D)\crypto\x509v3\v3_bitst.c
	$(CC) /Fo$(OBJ_D)\v3_bitst.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_bitst.c

$(OBJ_D)\v3_conf.obj: $(SRC_D)\crypto\x509v3\v3_conf.c
	$(CC) /Fo$(OBJ_D)\v3_conf.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_conf.c

$(OBJ_D)\v3_extku.obj: $(SRC_D)\crypto\x509v3\v3_extku.c
	$(CC) /Fo$(OBJ_D)\v3_extku.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_extku.c

$(OBJ_D)\v3_ia5.obj: $(SRC_D)\crypto\x509v3\v3_ia5.c
	$(CC) /Fo$(OBJ_D)\v3_ia5.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_ia5.c

$(OBJ_D)\v3_lib.obj: $(SRC_D)\crypto\x509v3\v3_lib.c
	$(CC) /Fo$(OBJ_D)\v3_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_lib.c

$(OBJ_D)\v3_prn.obj: $(SRC_D)\crypto\x509v3\v3_prn.c
	$(CC) /Fo$(OBJ_D)\v3_prn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_prn.c

$(OBJ_D)\v3_utl.obj: $(SRC_D)\crypto\x509v3\v3_utl.c
	$(CC) /Fo$(OBJ_D)\v3_utl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_utl.c

$(OBJ_D)\v3err.obj: $(SRC_D)\crypto\x509v3\v3err.c
	$(CC) /Fo$(OBJ_D)\v3err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3err.c

$(OBJ_D)\v3_genn.obj: $(SRC_D)\crypto\x509v3\v3_genn.c
	$(CC) /Fo$(OBJ_D)\v3_genn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_genn.c

$(OBJ_D)\v3_alt.obj: $(SRC_D)\crypto\x509v3\v3_alt.c
	$(CC) /Fo$(OBJ_D)\v3_alt.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_alt.c

$(OBJ_D)\v3_skey.obj: $(SRC_D)\crypto\x509v3\v3_skey.c
	$(CC) /Fo$(OBJ_D)\v3_skey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_skey.c

$(OBJ_D)\v3_akey.obj: $(SRC_D)\crypto\x509v3\v3_akey.c
	$(CC) /Fo$(OBJ_D)\v3_akey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_akey.c

$(OBJ_D)\v3_pku.obj: $(SRC_D)\crypto\x509v3\v3_pku.c
	$(CC) /Fo$(OBJ_D)\v3_pku.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_pku.c

$(OBJ_D)\v3_int.obj: $(SRC_D)\crypto\x509v3\v3_int.c
	$(CC) /Fo$(OBJ_D)\v3_int.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_int.c

$(OBJ_D)\v3_enum.obj: $(SRC_D)\crypto\x509v3\v3_enum.c
	$(CC) /Fo$(OBJ_D)\v3_enum.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_enum.c

$(OBJ_D)\v3_sxnet.obj: $(SRC_D)\crypto\x509v3\v3_sxnet.c
	$(CC) /Fo$(OBJ_D)\v3_sxnet.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_sxnet.c

$(OBJ_D)\v3_cpols.obj: $(SRC_D)\crypto\x509v3\v3_cpols.c
	$(CC) /Fo$(OBJ_D)\v3_cpols.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_cpols.c

$(OBJ_D)\v3_crld.obj: $(SRC_D)\crypto\x509v3\v3_crld.c
	$(CC) /Fo$(OBJ_D)\v3_crld.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_crld.c

$(OBJ_D)\v3_purp.obj: $(SRC_D)\crypto\x509v3\v3_purp.c
	$(CC) /Fo$(OBJ_D)\v3_purp.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_purp.c

$(OBJ_D)\v3_info.obj: $(SRC_D)\crypto\x509v3\v3_info.c
	$(CC) /Fo$(OBJ_D)\v3_info.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_info.c

$(OBJ_D)\v3_ocsp.obj: $(SRC_D)\crypto\x509v3\v3_ocsp.c
	$(CC) /Fo$(OBJ_D)\v3_ocsp.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_ocsp.c

$(OBJ_D)\v3_akeya.obj: $(SRC_D)\crypto\x509v3\v3_akeya.c
	$(CC) /Fo$(OBJ_D)\v3_akeya.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_akeya.c

$(OBJ_D)\v3_pmaps.obj: $(SRC_D)\crypto\x509v3\v3_pmaps.c
	$(CC) /Fo$(OBJ_D)\v3_pmaps.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_pmaps.c

$(OBJ_D)\v3_pcons.obj: $(SRC_D)\crypto\x509v3\v3_pcons.c
	$(CC) /Fo$(OBJ_D)\v3_pcons.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_pcons.c

$(OBJ_D)\v3_ncons.obj: $(SRC_D)\crypto\x509v3\v3_ncons.c
	$(CC) /Fo$(OBJ_D)\v3_ncons.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_ncons.c

$(OBJ_D)\v3_pcia.obj: $(SRC_D)\crypto\x509v3\v3_pcia.c
	$(CC) /Fo$(OBJ_D)\v3_pcia.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_pcia.c

$(OBJ_D)\v3_pci.obj: $(SRC_D)\crypto\x509v3\v3_pci.c
	$(CC) /Fo$(OBJ_D)\v3_pci.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_pci.c

$(OBJ_D)\pcy_cache.obj: $(SRC_D)\crypto\x509v3\pcy_cache.c
	$(CC) /Fo$(OBJ_D)\pcy_cache.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\pcy_cache.c

$(OBJ_D)\pcy_node.obj: $(SRC_D)\crypto\x509v3\pcy_node.c
	$(CC) /Fo$(OBJ_D)\pcy_node.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\pcy_node.c

$(OBJ_D)\pcy_data.obj: $(SRC_D)\crypto\x509v3\pcy_data.c
	$(CC) /Fo$(OBJ_D)\pcy_data.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\pcy_data.c

$(OBJ_D)\pcy_map.obj: $(SRC_D)\crypto\x509v3\pcy_map.c
	$(CC) /Fo$(OBJ_D)\pcy_map.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\pcy_map.c

$(OBJ_D)\pcy_tree.obj: $(SRC_D)\crypto\x509v3\pcy_tree.c
	$(CC) /Fo$(OBJ_D)\pcy_tree.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\pcy_tree.c

$(OBJ_D)\pcy_lib.obj: $(SRC_D)\crypto\x509v3\pcy_lib.c
	$(CC) /Fo$(OBJ_D)\pcy_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\pcy_lib.c

$(OBJ_D)\v3_asid.obj: $(SRC_D)\crypto\x509v3\v3_asid.c
	$(CC) /Fo$(OBJ_D)\v3_asid.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_asid.c

$(OBJ_D)\v3_addr.obj: $(SRC_D)\crypto\x509v3\v3_addr.c
	$(CC) /Fo$(OBJ_D)\v3_addr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\x509v3\v3_addr.c

$(OBJ_D)\conf_err.obj: $(SRC_D)\crypto\conf\conf_err.c
	$(CC) /Fo$(OBJ_D)\conf_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\conf\conf_err.c

$(OBJ_D)\conf_lib.obj: $(SRC_D)\crypto\conf\conf_lib.c
	$(CC) /Fo$(OBJ_D)\conf_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\conf\conf_lib.c

$(OBJ_D)\conf_api.obj: $(SRC_D)\crypto\conf\conf_api.c
	$(CC) /Fo$(OBJ_D)\conf_api.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\conf\conf_api.c

$(OBJ_D)\conf_def.obj: $(SRC_D)\crypto\conf\conf_def.c
	$(CC) /Fo$(OBJ_D)\conf_def.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\conf\conf_def.c

$(OBJ_D)\conf_mod.obj: $(SRC_D)\crypto\conf\conf_mod.c
	$(CC) /Fo$(OBJ_D)\conf_mod.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\conf\conf_mod.c

$(OBJ_D)\conf_mall.obj: $(SRC_D)\crypto\conf\conf_mall.c
	$(CC) /Fo$(OBJ_D)\conf_mall.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\conf\conf_mall.c

$(OBJ_D)\conf_sap.obj: $(SRC_D)\crypto\conf\conf_sap.c
	$(CC) /Fo$(OBJ_D)\conf_sap.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\conf\conf_sap.c

$(OBJ_D)\txt_db.obj: $(SRC_D)\crypto\txt_db\txt_db.c
	$(CC) /Fo$(OBJ_D)\txt_db.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\txt_db\txt_db.c

$(OBJ_D)\pk7_asn1.obj: $(SRC_D)\crypto\pkcs7\pk7_asn1.c
	$(CC) /Fo$(OBJ_D)\pk7_asn1.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs7\pk7_asn1.c

$(OBJ_D)\pk7_lib.obj: $(SRC_D)\crypto\pkcs7\pk7_lib.c
	$(CC) /Fo$(OBJ_D)\pk7_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs7\pk7_lib.c

$(OBJ_D)\pkcs7err.obj: $(SRC_D)\crypto\pkcs7\pkcs7err.c
	$(CC) /Fo$(OBJ_D)\pkcs7err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs7\pkcs7err.c

$(OBJ_D)\pk7_doit.obj: $(SRC_D)\crypto\pkcs7\pk7_doit.c
	$(CC) /Fo$(OBJ_D)\pk7_doit.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs7\pk7_doit.c

$(OBJ_D)\pk7_smime.obj: $(SRC_D)\crypto\pkcs7\pk7_smime.c
	$(CC) /Fo$(OBJ_D)\pk7_smime.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs7\pk7_smime.c

$(OBJ_D)\pk7_attr.obj: $(SRC_D)\crypto\pkcs7\pk7_attr.c
	$(CC) /Fo$(OBJ_D)\pk7_attr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs7\pk7_attr.c

$(OBJ_D)\pk7_mime.obj: $(SRC_D)\crypto\pkcs7\pk7_mime.c
	$(CC) /Fo$(OBJ_D)\pk7_mime.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs7\pk7_mime.c

$(OBJ_D)\bio_pk7.obj: $(SRC_D)\crypto\pkcs7\bio_pk7.c
	$(CC) /Fo$(OBJ_D)\bio_pk7.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs7\bio_pk7.c

$(OBJ_D)\p12_add.obj: $(SRC_D)\crypto\pkcs12\p12_add.c
	$(CC) /Fo$(OBJ_D)\p12_add.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_add.c

$(OBJ_D)\p12_asn.obj: $(SRC_D)\crypto\pkcs12\p12_asn.c
	$(CC) /Fo$(OBJ_D)\p12_asn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_asn.c

$(OBJ_D)\p12_attr.obj: $(SRC_D)\crypto\pkcs12\p12_attr.c
	$(CC) /Fo$(OBJ_D)\p12_attr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_attr.c

$(OBJ_D)\p12_crpt.obj: $(SRC_D)\crypto\pkcs12\p12_crpt.c
	$(CC) /Fo$(OBJ_D)\p12_crpt.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_crpt.c

$(OBJ_D)\p12_crt.obj: $(SRC_D)\crypto\pkcs12\p12_crt.c
	$(CC) /Fo$(OBJ_D)\p12_crt.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_crt.c

$(OBJ_D)\p12_decr.obj: $(SRC_D)\crypto\pkcs12\p12_decr.c
	$(CC) /Fo$(OBJ_D)\p12_decr.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_decr.c

$(OBJ_D)\p12_init.obj: $(SRC_D)\crypto\pkcs12\p12_init.c
	$(CC) /Fo$(OBJ_D)\p12_init.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_init.c

$(OBJ_D)\p12_key.obj: $(SRC_D)\crypto\pkcs12\p12_key.c
	$(CC) /Fo$(OBJ_D)\p12_key.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_key.c

$(OBJ_D)\p12_kiss.obj: $(SRC_D)\crypto\pkcs12\p12_kiss.c
	$(CC) /Fo$(OBJ_D)\p12_kiss.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_kiss.c

$(OBJ_D)\p12_mutl.obj: $(SRC_D)\crypto\pkcs12\p12_mutl.c
	$(CC) /Fo$(OBJ_D)\p12_mutl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_mutl.c

$(OBJ_D)\p12_utl.obj: $(SRC_D)\crypto\pkcs12\p12_utl.c
	$(CC) /Fo$(OBJ_D)\p12_utl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_utl.c

$(OBJ_D)\p12_npas.obj: $(SRC_D)\crypto\pkcs12\p12_npas.c
	$(CC) /Fo$(OBJ_D)\p12_npas.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_npas.c

$(OBJ_D)\pk12err.obj: $(SRC_D)\crypto\pkcs12\pk12err.c
	$(CC) /Fo$(OBJ_D)\pk12err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\pk12err.c

$(OBJ_D)\p12_p8d.obj: $(SRC_D)\crypto\pkcs12\p12_p8d.c
	$(CC) /Fo$(OBJ_D)\p12_p8d.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_p8d.c

$(OBJ_D)\p12_p8e.obj: $(SRC_D)\crypto\pkcs12\p12_p8e.c
	$(CC) /Fo$(OBJ_D)\p12_p8e.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pkcs12\p12_p8e.c

$(OBJ_D)\comp_lib.obj: $(SRC_D)\crypto\comp\comp_lib.c
	$(CC) /Fo$(OBJ_D)\comp_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\comp\comp_lib.c

$(OBJ_D)\comp_err.obj: $(SRC_D)\crypto\comp\comp_err.c
	$(CC) /Fo$(OBJ_D)\comp_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\comp\comp_err.c

$(OBJ_D)\c_rle.obj: $(SRC_D)\crypto\comp\c_rle.c
	$(CC) /Fo$(OBJ_D)\c_rle.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\comp\c_rle.c

$(OBJ_D)\c_zlib.obj: $(SRC_D)\crypto\comp\c_zlib.c
	$(CC) /Fo$(OBJ_D)\c_zlib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\comp\c_zlib.c

$(OBJ_D)\eng_err.obj: $(SRC_D)\crypto\engine\eng_err.c
	$(CC) /Fo$(OBJ_D)\eng_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_err.c

$(OBJ_D)\eng_lib.obj: $(SRC_D)\crypto\engine\eng_lib.c
	$(CC) /Fo$(OBJ_D)\eng_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_lib.c

$(OBJ_D)\eng_list.obj: $(SRC_D)\crypto\engine\eng_list.c
	$(CC) /Fo$(OBJ_D)\eng_list.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_list.c

$(OBJ_D)\eng_init.obj: $(SRC_D)\crypto\engine\eng_init.c
	$(CC) /Fo$(OBJ_D)\eng_init.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_init.c

$(OBJ_D)\eng_ctrl.obj: $(SRC_D)\crypto\engine\eng_ctrl.c
	$(CC) /Fo$(OBJ_D)\eng_ctrl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_ctrl.c

$(OBJ_D)\eng_table.obj: $(SRC_D)\crypto\engine\eng_table.c
	$(CC) /Fo$(OBJ_D)\eng_table.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_table.c

$(OBJ_D)\eng_pkey.obj: $(SRC_D)\crypto\engine\eng_pkey.c
	$(CC) /Fo$(OBJ_D)\eng_pkey.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_pkey.c

$(OBJ_D)\eng_fat.obj: $(SRC_D)\crypto\engine\eng_fat.c
	$(CC) /Fo$(OBJ_D)\eng_fat.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_fat.c

$(OBJ_D)\eng_all.obj: $(SRC_D)\crypto\engine\eng_all.c
	$(CC) /Fo$(OBJ_D)\eng_all.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_all.c

$(OBJ_D)\tb_rsa.obj: $(SRC_D)\crypto\engine\tb_rsa.c
	$(CC) /Fo$(OBJ_D)\tb_rsa.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\tb_rsa.c

$(OBJ_D)\tb_dsa.obj: $(SRC_D)\crypto\engine\tb_dsa.c
	$(CC) /Fo$(OBJ_D)\tb_dsa.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\tb_dsa.c

$(OBJ_D)\tb_ecdsa.obj: $(SRC_D)\crypto\engine\tb_ecdsa.c
	$(CC) /Fo$(OBJ_D)\tb_ecdsa.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\tb_ecdsa.c

$(OBJ_D)\tb_dh.obj: $(SRC_D)\crypto\engine\tb_dh.c
	$(CC) /Fo$(OBJ_D)\tb_dh.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\tb_dh.c

$(OBJ_D)\tb_ecdh.obj: $(SRC_D)\crypto\engine\tb_ecdh.c
	$(CC) /Fo$(OBJ_D)\tb_ecdh.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\tb_ecdh.c

$(OBJ_D)\tb_rand.obj: $(SRC_D)\crypto\engine\tb_rand.c
	$(CC) /Fo$(OBJ_D)\tb_rand.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\tb_rand.c

$(OBJ_D)\tb_store.obj: $(SRC_D)\crypto\engine\tb_store.c
	$(CC) /Fo$(OBJ_D)\tb_store.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\tb_store.c

$(OBJ_D)\tb_cipher.obj: $(SRC_D)\crypto\engine\tb_cipher.c
	$(CC) /Fo$(OBJ_D)\tb_cipher.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\tb_cipher.c

$(OBJ_D)\tb_digest.obj: $(SRC_D)\crypto\engine\tb_digest.c
	$(CC) /Fo$(OBJ_D)\tb_digest.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\tb_digest.c

$(OBJ_D)\tb_pkmeth.obj: $(SRC_D)\crypto\engine\tb_pkmeth.c
	$(CC) /Fo$(OBJ_D)\tb_pkmeth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\tb_pkmeth.c

$(OBJ_D)\tb_asnmth.obj: $(SRC_D)\crypto\engine\tb_asnmth.c
	$(CC) /Fo$(OBJ_D)\tb_asnmth.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\tb_asnmth.c

$(OBJ_D)\eng_openssl.obj: $(SRC_D)\crypto\engine\eng_openssl.c
	$(CC) /Fo$(OBJ_D)\eng_openssl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_openssl.c

$(OBJ_D)\eng_cnf.obj: $(SRC_D)\crypto\engine\eng_cnf.c
	$(CC) /Fo$(OBJ_D)\eng_cnf.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_cnf.c

$(OBJ_D)\eng_dyn.obj: $(SRC_D)\crypto\engine\eng_dyn.c
	$(CC) /Fo$(OBJ_D)\eng_dyn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_dyn.c

$(OBJ_D)\eng_cryptodev.obj: $(SRC_D)\crypto\engine\eng_cryptodev.c
	$(CC) /Fo$(OBJ_D)\eng_cryptodev.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_cryptodev.c

$(OBJ_D)\eng_rsax.obj: $(SRC_D)\crypto\engine\eng_rsax.c
	$(CC) /Fo$(OBJ_D)\eng_rsax.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_rsax.c

$(OBJ_D)\eng_rdrand.obj: $(SRC_D)\crypto\engine\eng_rdrand.c
	$(CC) /Fo$(OBJ_D)\eng_rdrand.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\engine\eng_rdrand.c

$(OBJ_D)\ocsp_asn.obj: $(SRC_D)\crypto\ocsp\ocsp_asn.c
	$(CC) /Fo$(OBJ_D)\ocsp_asn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ocsp\ocsp_asn.c

$(OBJ_D)\ocsp_ext.obj: $(SRC_D)\crypto\ocsp\ocsp_ext.c
	$(CC) /Fo$(OBJ_D)\ocsp_ext.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ocsp\ocsp_ext.c

$(OBJ_D)\ocsp_ht.obj: $(SRC_D)\crypto\ocsp\ocsp_ht.c
	$(CC) /Fo$(OBJ_D)\ocsp_ht.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ocsp\ocsp_ht.c

$(OBJ_D)\ocsp_lib.obj: $(SRC_D)\crypto\ocsp\ocsp_lib.c
	$(CC) /Fo$(OBJ_D)\ocsp_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ocsp\ocsp_lib.c

$(OBJ_D)\ocsp_cl.obj: $(SRC_D)\crypto\ocsp\ocsp_cl.c
	$(CC) /Fo$(OBJ_D)\ocsp_cl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ocsp\ocsp_cl.c

$(OBJ_D)\ocsp_srv.obj: $(SRC_D)\crypto\ocsp\ocsp_srv.c
	$(CC) /Fo$(OBJ_D)\ocsp_srv.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ocsp\ocsp_srv.c

$(OBJ_D)\ocsp_prn.obj: $(SRC_D)\crypto\ocsp\ocsp_prn.c
	$(CC) /Fo$(OBJ_D)\ocsp_prn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ocsp\ocsp_prn.c

$(OBJ_D)\ocsp_vfy.obj: $(SRC_D)\crypto\ocsp\ocsp_vfy.c
	$(CC) /Fo$(OBJ_D)\ocsp_vfy.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ocsp\ocsp_vfy.c

$(OBJ_D)\ocsp_err.obj: $(SRC_D)\crypto\ocsp\ocsp_err.c
	$(CC) /Fo$(OBJ_D)\ocsp_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ocsp\ocsp_err.c

$(OBJ_D)\ui_err.obj: $(SRC_D)\crypto\ui\ui_err.c
	$(CC) /Fo$(OBJ_D)\ui_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ui\ui_err.c

$(OBJ_D)\ui_lib.obj: $(SRC_D)\crypto\ui\ui_lib.c
	$(CC) /Fo$(OBJ_D)\ui_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ui\ui_lib.c

$(OBJ_D)\ui_openssl.obj: $(SRC_D)\crypto\ui\ui_openssl.c
	$(CC) /Fo$(OBJ_D)\ui_openssl.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ui\ui_openssl.c

$(OBJ_D)\ui_util.obj: $(SRC_D)\crypto\ui\ui_util.c
	$(CC) /Fo$(OBJ_D)\ui_util.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ui\ui_util.c

$(OBJ_D)\ui_compat.obj: $(SRC_D)\crypto\ui\ui_compat.c
	$(CC) /Fo$(OBJ_D)\ui_compat.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ui\ui_compat.c

$(OBJ_D)\krb5_asn.obj: $(SRC_D)\crypto\krb5\krb5_asn.c
	$(CC) /Fo$(OBJ_D)\krb5_asn.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\krb5\krb5_asn.c

$(OBJ_D)\pqueue.obj: $(SRC_D)\crypto\pqueue\pqueue.c
	$(CC) /Fo$(OBJ_D)\pqueue.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\pqueue\pqueue.c

$(OBJ_D)\wp_dgst.obj: $(SRC_D)\crypto\whrlpool\wp_dgst.c
	$(CC) /Fo$(OBJ_D)\wp_dgst.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\whrlpool\wp_dgst.c

$(OBJ_D)\wp_block.obj: $(SRC_D)\crypto\whrlpool\wp_block.c
	$(CC) /Fo$(OBJ_D)\wp_block.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\whrlpool\wp_block.c

$(TMP_D)\wp-mmx.asm: crypto\whrlpool\asm\wp-mmx.pl
	$(PERL) crypto\whrlpool\asm\wp-mmx.pl win32 $(CFLAG) >$@

$(OBJ_D)\wp-mmx.obj: $(TMP_D)\wp-mmx.asm
	$(ASM) /Fo$@ $(TMP_D)\wp-mmx.asm

$(OBJ_D)\ts_err.obj: $(SRC_D)\crypto\ts\ts_err.c
	$(CC) /Fo$(OBJ_D)\ts_err.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ts\ts_err.c

$(OBJ_D)\ts_req_utils.obj: $(SRC_D)\crypto\ts\ts_req_utils.c
	$(CC) /Fo$(OBJ_D)\ts_req_utils.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ts\ts_req_utils.c

$(OBJ_D)\ts_req_print.obj: $(SRC_D)\crypto\ts\ts_req_print.c
	$(CC) /Fo$(OBJ_D)\ts_req_print.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ts\ts_req_print.c

$(OBJ_D)\ts_rsp_utils.obj: $(SRC_D)\crypto\ts\ts_rsp_utils.c
	$(CC) /Fo$(OBJ_D)\ts_rsp_utils.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ts\ts_rsp_utils.c

$(OBJ_D)\ts_rsp_print.obj: $(SRC_D)\crypto\ts\ts_rsp_print.c
	$(CC) /Fo$(OBJ_D)\ts_rsp_print.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ts\ts_rsp_print.c

$(OBJ_D)\ts_rsp_sign.obj: $(SRC_D)\crypto\ts\ts_rsp_sign.c
	$(CC) /Fo$(OBJ_D)\ts_rsp_sign.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ts\ts_rsp_sign.c

$(OBJ_D)\ts_rsp_verify.obj: $(SRC_D)\crypto\ts\ts_rsp_verify.c
	$(CC) /Fo$(OBJ_D)\ts_rsp_verify.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ts\ts_rsp_verify.c

$(OBJ_D)\ts_verify_ctx.obj: $(SRC_D)\crypto\ts\ts_verify_ctx.c
	$(CC) /Fo$(OBJ_D)\ts_verify_ctx.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ts\ts_verify_ctx.c

$(OBJ_D)\ts_lib.obj: $(SRC_D)\crypto\ts\ts_lib.c
	$(CC) /Fo$(OBJ_D)\ts_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ts\ts_lib.c

$(OBJ_D)\ts_conf.obj: $(SRC_D)\crypto\ts\ts_conf.c
	$(CC) /Fo$(OBJ_D)\ts_conf.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ts\ts_conf.c

$(OBJ_D)\ts_asn1.obj: $(SRC_D)\crypto\ts\ts_asn1.c
	$(CC) /Fo$(OBJ_D)\ts_asn1.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\ts\ts_asn1.c

$(OBJ_D)\srp_lib.obj: $(SRC_D)\crypto\srp\srp_lib.c
	$(CC) /Fo$(OBJ_D)\srp_lib.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\srp\srp_lib.c

$(OBJ_D)\srp_vfy.obj: $(SRC_D)\crypto\srp\srp_vfy.c
	$(CC) /Fo$(OBJ_D)\srp_vfy.obj  $(LIB_CFLAGS) -c $(SRC_D)\crypto\srp\srp_vfy.c

$(OBJ_D)\$(CRYPTO).res: ms\version32.rc
	$(RSC) /fo"$(OBJ_D)\$(CRYPTO).res" /d CRYPTO ms\version32.rc

$(O_CRYPTO): $(CRYPTOOBJ)
	$(MKLIB) /out:$(O_CRYPTO) @<<
  $(CRYPTOOBJ)
<<
